############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXLicense;no warnings;(my $virtualSessionSupport=(0x0310+ 7618-0x20d2));
(my $physicalSessionSupport=(0x1030+ 4168-0x2078));(my $foreignSessionSupport=
(0x08b2+ 473-0x0a8b));(my $customFreeSubscriptionMessage=(0x05e0+ 7977-0x2509));
($licenseFormat="\x34");sub isPhysicalSessionSupportEnabled{return (
$physicalSessionSupport);}sub isVirtualSessionSupportEnabled{return (
$virtualSessionSupport);}sub isForeignSessionSupportEnabled{return (
$foreignSessionSupport);}sub isVirtualSessionSupportDisabled{return ((!
isVirtualSessionSupportEnabled ()));}sub isCustomFreeSubscriptionMessage{return 
($customFreeSubscriptionMessage);}sub enablePhysicalSessionSupport{(
$physicalSessionSupport=(0x0ed6+ 5822-0x2593));}sub enableVirtualSessionSupport{
($virtualSessionSupport=(0x2474+ 192-0x2533));}sub enableForeignSessionSupport{(
$foreignSessionSupport=(0x0ac3+ 4908-0x1dee));}sub 
enableCustomFreeSubscriptionMessage{($customFreeSubscriptionMessage=
(0x01c7+ 7386-0x1ea0));}sub chk_license{(my $subscription_mode=(shift (@_)||("")
));(my $selected_server_id=(shift (@_)||"\x30"));(my (@licenses)=());if ((
$subscription_mode ne (""))){($subscription_mode=(0x095a+ 5606-0x1f3f));}else{(
$subscription_mode=(0x0a3d+ 3749-0x18e2));}(my (@licenseFile)=
load_license_from_file ());(my (@licencje)=convertToArray (@licenseFile));undef 
(@licenseFile);(my (@parsed_licenses)=convertArrayToLicArray (@licencje));if (($#parsed_licenses
==(-(0x0b88+ 1908-0x12fb)))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x0b48+ 3150-0x1795));}(my $num=(-(0x0021+ 7543-0x1d97)));
foreach my $lic (@parsed_licenses){(++$num);($lic=verify_entry ($lic));if ((
$selected_server_id ne "\x30")){if ((defined ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})and ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq $selected_server_id))){if ((
$subscription_mode==(0x122a+ 1345-0x176a))){show_lic ($lic);}return (
(0x1af7+ 457-0x1cc0));}else{next;}}if (defined ($$lic{"\x65\x72\x72\x6f\x72"})){
if (($subscription_mode==(0x08f2+ 6044-0x208d))){show_lic ($lic);next;}else{if (
($num eq$#parsed_licenses)){if (Common::NXMsg::check_msg ($$lic{
"\x65\x72\x72\x6f\x72"})){Common::NXMsg::error ($$lic{"\x65\x72\x72\x6f\x72"});}
main::nxexit ((0x1044+ 2993-0x1bf4));}next;}}if (defined ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74"})){($GLOBAL::PRODUCT_NAME=$$lic{
"\x50\x72\x6f\x64\x75\x63\x74"});}if (($$lic{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x030a+ 103-0x0370));}if (($GLOBAL::SERVER_PRODUCT_KEY ne (""))
){if (($$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq 
$GLOBAL::SERVER_PRODUCT_KEY)){if (($$lic{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x0dab+ 6110-0x2588));}else{set_product ($lic);return ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"});}}}
elsif (($subscription_mode eq (0x15c2+ 1483-0x1b8c))){show_lic ($lic);}elsif (((
$$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}ne (""))and (
$selected_server_id eq ("")))){next;}else{set_product ($lic);return ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"});}}if ((
defined ($selected_server_id)and ($selected_server_id ne "\x30"))){
Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
,$selected_server_id);Common::NXMsg::send_response ("\x65\x42\x79\x65");return (
(0x1066+ 5525-0x25fb));}return ("\x4d\x69\x73\x73\x65\x64");}sub validate{(my $subscription_key
=(""));(my $subscription_type=(""));sub BEGIN{require Time::Local;do{
"\x54\x69\x6d\x65\x3a\x3a\x4c\x6f\x63\x61\x6c"->import};}(my $date=
Common::NXTime::getDateString ());chomp ($date);(my (@mon_list)=("\x4a\x61\x6e",
"\x46\x65\x62","\x4d\x61\x72","\x41\x70\x72","\x4d\x61\x79","\x4a\x75\x6e",
"\x4a\x75\x6c","\x41\x75\x67","\x53\x65\x70","\x4f\x63\x74","\x4e\x6f\x76",
"\x44\x65\x63"));(my (@day_list)=("\x53\x75\x6e","\x4d\x6f\x6e","\x54\x75\x65",
"\x57\x65\x64","\x54\x68\x75","\x46\x72\x69","\x53\x61\x74"));my ($sec,$min,
$hour,$mday,$mon,$year,$tz);if (($date=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*)(\d\d\d\d)/ )
){(($sec,$min,$hour,$mday,$mon,$year,$tz)=($6,$5,$4,$3,$2,$8,$7));($mon=~ s/Jan/00/i )
;($mon=~ s/Feb/01/i );($mon=~ s/Mar/02/i );($mon=~ s/Apr/03/i );($mon=~ s/May/04/i )
;($mon=~ s/Jun/05/i );($mon=~ s/Jul/06/i );($mon=~ s/Aug/07/i );($mon=~ s/Sep/08/i )
;($mon=~ s/Oct/09/i );($mon=~ s/Nov/10/i );($mon=~ s/Dec/11/i );if (($tz eq ("")
)){($tz="\x43\x45\x53\x54");($date=~ s/(\d\d\d\d)$/$tz $1/ );}}else{
Common::NXMsg::error (
"\x65\x44\x61\x74\x65\x49\x6e\x55\x6e\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x64\x46\x6f\x72\x6d\x61\x74"
,$date);main::nxexit ((0x07a4+ 7170-0x23a5));}(my $Nts=Time::Local::timelocal (
$sec,$min,$hour,$mday,$mon,$year));($Nts+=2592000);(my ($sec,$min,$hour,$mday,
$mon,$year,$wday,$yday,$isdst)=Common::NXTime::getLocalTimeFromTimestamp ($Nts))
;($year+=(0x1ff5+ 2524-0x2265));(my $expiryDate=((((((((((($day_list[$wday].
"\x20").$mon_list[$mon])."\x20").$mday)."\x20").sprintf ("\x25\x30\x32\x64",
$hour))."\x3a").sprintf ("\x25\x30\x32\x64",$min))."\x3a").sprintf (
"\x25\x30\x32\x64",$sec)).((("\x20".$tz)."\x20").$year)));(my $KEY_FD=
main::nxopen (($GLOBAL::PRODUCT_KEY_FILE."\x2e\x73\x61\x6d\x70\x6c\x65"),
$NXBits::O_RDONLY,(0x073a+ 6749-0x2197)));if ((not (defined ($KEY_FD)))){
main::nxexit ((0x054d+ 1734-0x0c12));}(my $content=(""));while (main::nxreadLine
 ($KEY_FD,(\$_))){if (( /^----- Begin subscription data -----(\r*)$/ .. /^----- End subscription data -----(\r*)$/ )
){($content.=$_);}}main::nxclose ($KEY_FD);($content=~ s/\r+//gm );if (($content
=~ /^Subscription Type: +(.*)$/m )){($subscription_type=$1);}if ((not (($content
=~ /^Virtual Desktops: +(.*)$/m )))){($licenseFormat="\x33");}if ((
$subscription_type ne "\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e")){main::nxexit 
((0x06eb+ 7790-0x2558));}if (($content=~ /^Subscription Key: +(.*)$/m )){(
$subscription_key=$1);}($content=~ s/^(Date: +).*$/$1/m );($content=~ s/^(Expiry: +).*$/$1/m )
;($content=~ s/^(Subscription Key: +).*$/$1/m );($content=~ s/----- Begin subscription data -----\n//m )
;($content=~ s/----- End subscription data -----\n*//m );($content=~ s/(^Date:                   )/$1$date/m )
;($content=~ s/(^Expiry:                 )/$1$expiryDate/m );my (
$c_subscription_key);(my $add_chr=substr (Common::NXCore::digestMd5Hex ($date),
(0x0a82+ 1886-0x11e0),(0x0543+ 6873-0x2014)));if (($licenseFormat eq "\x33")){(
$c_subscription_key=Common::NXCore::digestMd5Hex (($content.
$GLOBAL::PRODUCT_KEY_SALT)));}else{($c_subscription_key=(
Common::NXCore::digestMd5Hex (($content.$GLOBAL::PRODUCT_KEY_SALT)).$add_chr));}
($content=~ s/(^Subscription Key:       )/$1$c_subscription_key/m );($KEY_FD=
main::nxopen (($GLOBAL::PRODUCT_KEY_FILE."\x2e\x73\x61\x6d\x70\x6c\x65"),((
$NXBits::O_WRONLY+$NXBits::O_TRUNC)+$NXBits::O_CREAT),(($NXBits::UserReadWrite+
$NXBits::GroupReadWrite)+$NXBits::OthersReadWrite)));if ((not (defined ($KEY_FD)
))){main::nxexit ((0x0a52+ 6482-0x23a3));}main::nxwrite ($KEY_FD,((
"\x0a\x2d\x2d\x2d\x2d\x2d\x20\x42\x65\x67\x69\x6e\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x64\x61\x74\x61\x20\x2d\x2d\x2d\x2d\x2d\x0a"
.$content).
"\x2d\x2d\x2d\x2d\x2d\x20\x45\x6e\x64\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x64\x61\x74\x61\x20\x2d\x2d\x2d\x2d\x2d\x0a\x0a"
));main::nxclose ($KEY_FD);}sub serverLicExist{if (Common::NXFile::isExists (
$GLOBAL::NXSERVER_PRODUCT_KEY_FILE)){return ((0x0667+  43-0x0691));}else{return 
((0x2492+ 314-0x25cc));}}sub set_product{(my $lic=shift (@_));(
$GLOBAL::PRODUCT_ID=$$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"});(
$GLOBAL::CONNECTIONS_LIMIT=$$lic{"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}
);($$lic{"\x50\x72\x6f\x64\x75\x63\x74"}=~ s/NoMachine Portal Server/NoMachine Enterprise Terminal Server/ )
;($$lic{"\x50\x72\x6f\x64\x75\x63\x74"}=~ s/NoMachine Enterprise Server/NoMachine Enterprise Terminal Server/ )
;($GLOBAL::PRODUCT_NAME=$$lic{"\x50\x72\x6f\x64\x75\x63\x74"});if (
libnxh::NXIsValidAcronymId ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})){
($GLOBAL::SUBSCRIPTION_ID=$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"});
enablePhysicalSessionSupport ();if ((not (libnxh::NXIsEnterpriseDesktopNode (
$$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})))){
enableVirtualSessionSupport ();enableForeignSessionSupport ();}if (
libnxh::NXIsNomachineFreeServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})){
enableCustomFreeSubscriptionMessage ();}}else{Common::NXMsg::error (
"\x65\x47\x55\x49\x49\x6e\x76\x61\x6c\x69\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);Logger::error (
"\x54\x68\x65\x20\x6c\x69\x63\x65\x6e\x73\x65\x20\x69\x73\x20\x6e\x6f\x74\x20\x73\x75\x69\x74\x61\x62\x6c\x65\x20\x66\x6f\x72\x20\x74\x68\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x76\x65\x72\x73\x69\x6f\x6e\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x74\x68\x65"
);Logger::error (
"\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x53\x61\x6c\x65\x73\x20\x54\x65\x61\x6d\x20\x74\x6f\x20\x67\x65\x74\x20\x61\x20\x73\x75\x69\x74\x61\x62\x6c\x65\x20\x6c\x69\x63\x65\x6e\x73\x65\x2e"
);Logger::error (
"\x54\x68\x65\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x6e\x6f\x64\x65\x20\x63\x61\x6e\x6e\x6e\x6f\x74\x20\x70\x65\x72\x66\x6f\x72\x6d\x20\x74\x68\x65\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x2e"
);main::nxexit ((0x09c5+ 827-0x0d00));}}sub 
setProductAndWelcomeStringBaseOnHardcodedID{(my $productId=
libnxh::NXTransGetEnvironment ("\x4e\x58\x50\x52\x4f\x44\x55\x43\x54"));if ((
$productId eq (""))){($productId=$ENV{"\x4e\x58\x50\x52\x4f\x44\x55\x43\x54"});}
(my $acronymId=libnxh::NXParseServerProductId ($productId));if (
libnxh::NXIsValidAcronymId ($acronymId)){enablePhysicalSessionSupport ();if ((
not (libnxh::NXIsEnterpriseDesktop ($acronymId)))){enableVirtualSessionSupport 
();enableForeignSessionSupport ();}if (libnxh::NXIsNomachineFreeServer (
$acronymId)){enableCustomFreeSubscriptionMessage ();}}($GLOBAL::PRODUCT_ID=
$productId);($GLOBAL::PRODUCT_NAME=libnxh::NXParseProductName ($productId));(
$GLOBAL::WELCOME_STR=(($GLOBAL::PRODUCT_NAME.
"\x20\x2d\x20\x56\x65\x72\x73\x69\x6f\x6e\x20").$GLOBAL::SOFTWARE_RELEASE));(
$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_WELCOME_STR}=$GLOBAL::WELCOME_STR);}sub 
show_lic{(my $lic=shift (@_));if (defined ($$lic{"\x65\x72\x72\x6f\x72"})){
Common::NXMsg::send_response ("\x69\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79",
$$lic{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"});if (
Common::NXMsg::check_msg ($$lic{"\x65\x72\x72\x6f\x72"})){Common::NXMsg::error (
$$lic{"\x65\x72\x72\x6f\x72"});}return;}if (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e")){Logger::warning (
Common::NXMsg::getBrandedMessage (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e"
,$$lic{"\x45\x78\x70\x69\x72\x79"}));Common::NXMsg::send_response (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e"
,$$lic{"\x45\x78\x70\x69\x72\x79"});return;}elsif (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x45\x78\x70\x69\x72\x65\x64")){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x45\x78\x70\x69\x72\x65\x64"
);return;}elsif ((($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x4e\x6f\x6e\x65")and isCustomFreeSubscriptionMessage ())){
Common::NXMsg::send_response (
"\x77\x43\x6d\x64\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x46\x72\x65\x65"
);return;}elsif (((($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x4e\x6f\x6e\x65")or ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x50\x61\x72\x74\x6e\x65\x72"))or ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x44\x65\x76\x65\x6c\x6f\x70\x65\x72"))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x55\x6e\x73\x75\x62\x73\x63\x72\x69\x62\x65\x64"
);return;}elsif (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x53\x74\x61\x6e\x64\x61\x72\x64\x45\x78\x70\x69\x72\x65\x64")){main::nxwrite (
main::nxgetSTDOUT (),main::subscriptionInfo ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"},$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"},$$lic{
"\x70\x65\x72\x69\x6f\x64"},$$lic{
"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"},$$lic{
"\x45\x78\x70\x69\x72\x79"}));Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x78\x70\x69\x72\x65\x64"
);return;}Common::NXMsg::send_response (
"\x69\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79",$$lic{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"});main::nxwrite (
main::nxgetSTDOUT (),main::subscriptionInfo ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"},$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"},$$lic{
"\x70\x65\x72\x69\x6f\x64"},$$lic{
"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"},$$lic{
"\x45\x78\x70\x69\x72\x79"},"\x20\x20"));}sub verify_entry{(my $lic=shift (@_));my (
$sec,$min,$hour,$mday,$mon,$year);if (($$lic{"\x55\x73\x65\x72\x73"}=~ /nlimited$/ )
){($$lic{"\x55\x73\x65\x72\x73"}=(0x1785+ 1927-0x1f0c));}if (($$lic{
"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=~ /nlimited$/ )){($$lic{
"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=(0x155c+ 3631-0x238b));}($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}=libnxh::NXParseNodeProductId ($$lic{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x69\x64"}));if (((((((((((((not (
libnxh::NXIsTerminalServerNode ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"
})))and (not (libnxh::NXIsSmallBusinessServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseDesktopNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsQuickServerNode ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))
))and (not (libnxh::NXIsEnterpriseCloudServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsSmallBusinessTerminalServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseCloudServerClusterNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServerClusterNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsSmallBusinessCloudServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServersNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))){if (((not (defined ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})))or ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq ("")))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x0458+ 6825-0x1f00));}}if (($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}ne $GLOBAL::BUILD_PLATFORM)){
unless ((($GLOBAL::BUILD_PLATFORM eq "\x52")and (($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}eq "\x4c")||($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}eq "\x41")))){($$lic{
"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x50\x6c\x61\x74\x66\x6f\x72\x6d\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);return ($lic);}}if (($$lic{"\x45\x78\x70\x69\x72\x79"}ne 
"\x55\x6e\x6c\x69\x6d\x69\x74\x65\x64")){if (($$lic{"\x45\x78\x70\x69\x72\x79"}
=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*) (\d\d\d\d)/ )){(($sec,$min,
$hour,$mday,$mon,$year)=($6,$5,$4,$3,$2,$8));($mon=month2digit ($mon));}elsif ((
$$lic{"\x45\x78\x70\x69\x72\x79"}=~ /^.*(\d\d\d\d)-(\d\d)-(\d\d)/ )){($year=$1);
($mon=$2);($mday=$3);}else{($$lic{"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x78\x70\x69\x72\x79\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}(my $expiry=(($year.sprintf ("\x25\x30\x32\x64",$mon)).sprintf 
("\x25\x30\x32\x64",$mday)));(my $expiry_timestamp=Time::Local::timelocal ($sec,
$min,$hour,$mday,($mon-(0x09a1+ 7079-0x2547)),$year));my (@ltime);(@ltime=
Common::NXTime::getLocalTime ());(my $now=($ltime[(0x0651+ 6428-0x1f68)]+
(0x0e52+ 3091-0x12f9)));($now=($now.sprintf ("\x25\x30\x32\x64",($ltime[
(0x1be5+ 2039-0x23d8)]+(0x1229+ 3503-0x1fd7)))));($now=($now.sprintf (
"\x25\x30\x32\x64",$ltime[(0x07b1+ 6647-0x21a5)])));if (($$lic{
"\x44\x61\x74\x65"}=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*) (\d\d\d\d)/ )
){(($sec,$min,$hour,$mday,$mon,$year)=($6,$5,$4,$3,$2,$8));($mon=month2digit (
$mon));}elsif (($$lic{"\x44\x61\x74\x65"}=~ /^.*(\d\d\d\d)-(\d\d)-(\d\d)/ )){(
$year=$1);($mon=$2);($mday=$3);}else{($$lic{"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x44\x61\x74\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}(my $date=(($year.sprintf ("\x25\x30\x32\x64",$mon)).sprintf (
"\x25\x30\x32\x64",$mday)));(my $date_timestamp=Time::Local::timelocal ($sec,
$min,$hour,$mday,($mon-(0x0244+ 2717-0x0ce0)),$year));(my $period=(
$expiry_timestamp-$date_timestamp));($period=($period/86400));if ((($period eq 
(0x0c5f+ 6552-0x248a))or ($period eq (0x0c5a+ 6997-0x2641)))){($$lic{
"\x70\x65\x72\x69\x6f\x64"}="\x31\x20\x79\x65\x61\x72");}else{($$lic{
"\x70\x65\x72\x69\x6f\x64"}=(int ($period)."\x20\x64\x61\x79\x73"));}}else{(
$$lic{"\x70\x65\x72\x69\x6f\x64"}="\x55\x6e\x6c\x69\x6d\x69\x74\x65\x64");}if ((
$$lic{"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){($$lic{
"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}if ((not (defined ($$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79"})))
){(($$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"
},$$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79"})=buildday_formated ());}return ($lic
);}sub month2digit{(my $mon=shift (@_));($mon=~ s/Jan/00/i );($mon=~ s/Feb/01/i )
;($mon=~ s/Mar/02/i );($mon=~ s/Apr/03/i );($mon=~ s/May/04/i );($mon=~ s/Jun/05/i )
;($mon=~ s/Jul/06/i );($mon=~ s/Aug/07/i );($mon=~ s/Sep/08/i );($mon=~ s/Oct/09/i )
;($mon=~ s/Nov/10/i );($mon=~ s/Dec/11/i );(++$mon);return ($mon);}sub 
take_product_id{(my $content=shift (@_));my ($product_id);if (($content=~ /^Product Id: +(.)(.*)$/m )
){($product_id=$2);}return ($product_id);}sub take_platform_id{(my $content=
shift (@_));my ($platform_id);if (($content=~ /^Product Id: +(.)(.*)$/m )){(
$platform_id=$1);}return ($platform_id);}sub take_field_from_license{(my $field=
shift (@_));(my $content=shift (@_));if (($content=~ /^$field: +(.*)$/m )){(my $value
=$1);return ($value);}return;}sub convertArrayToLicArray{(my (@licencje)=@_);(my (
@result)=());foreach my $entry (@licencje){my ($tmp);($$tmp{
"\x43\x75\x73\x74\x6f\x6d\x65\x72"}=take_field_from_license (
"\x43\x75\x73\x74\x6f\x6d\x65\x72",$entry));($$tmp{"\x44\x61\x74\x65"}=
take_field_from_license ("\x44\x61\x74\x65",$entry));($$tmp{
"\x50\x72\x6f\x64\x75\x63\x74"}=take_field_from_license (
"\x50\x72\x6f\x64\x75\x63\x74",$entry));($$tmp{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"}=
take_field_from_license ("\x50\x72\x6f\x64\x75\x63\x74\x20\x49\x64",$entry));(
$$tmp{"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x49\x64",$entry));($$tmp{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x54\x79\x70\x65",$entry));
($$tmp{"\x45\x78\x70\x69\x72\x79"}=take_field_from_license (
"\x45\x78\x70\x69\x72\x61\x74\x69\x6f\x6e\x7c\x45\x78\x70\x69\x72\x79",$entry));
($$tmp{"\x55\x73\x65\x72\x73"}=take_field_from_license ("\x55\x73\x65\x72\x73",
$entry));($$tmp{"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=
take_field_from_license ("\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73",$entry))
;($$tmp{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}=take_field_from_license (
"\x53\x65\x72\x76\x65\x72\x20\x4b\x65\x79",$entry));($$tmp{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}=take_field_from_license (
"\x50\x72\x6f\x64\x75\x63\x74\x20\x4b\x65\x79",$entry));($$tmp{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x4b\x65\x79",$entry));(
$$tmp{"\x76\x69\x72\x74\x75\x61\x6c\x5f\x64\x65\x73\x6b\x74\x6f\x70\x73"}=
take_field_from_license (
"\x56\x69\x72\x74\x75\x61\x6c\x20\x44\x65\x73\x6b\x74\x6f\x70\x73",$entry));(
$$tmp{"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}=take_platform_id ($entry))
;($$tmp{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x69\x64"}=take_product_id ($entry));(
$$tmp{"\x6c\x69\x63\x65\x6e\x73\x65\x5f\x66\x69\x6c\x65"}=$entry);($$tmp{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}=
calculate_license_md5 ($entry));($$tmp{
"\x6c\x69\x63\x65\x6e\x73\x65\x5f\x76\x65\x72\x73\x69\x6f\x6e"}="\x34");if ((((
$$tmp{"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne (""))and (
$$tmp{"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"}ne ("")))and (
$$tmp{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}ne ("")))){push (@result,
$tmp);}}return (@result);}sub calculate_license_md5{(my $content=shift (@_));(my $date_formated
=(""));if (($content=~ /^Date: +(.*)$/m )){($date_formated=$1);}(my $add_chr=
substr (Common::NXCore::digestMd5Hex ($date_formated),(0x1638+ 2974-0x21d6),
(0x05c1+ 5165-0x19e6)));($content=~ s/^(Subscription Key: +).*$/$1/m );($content
=~ s/----- Begin subscription data -----\n//m );($content=~ s/----- End subscription data -----\n*//m )
;if (($content=~ /Virtual Desktops:/ )){return ((Common::NXCore::digestMd5Hex ((
$content.$GLOBAL::PRODUCT_KEY_SALT)).$add_chr));}else{return (
Common::NXCore::digestMd5Hex (($content.$GLOBAL::PRODUCT_KEY_SALT)));}}sub 
buildday_formated{(Common::NXCore::decodeDate ($GLOBAL::BUILD_DAY)=~ /(\d{4})(\d{2})(\d{2})/ )
;(my $buildday_timestamp=Time::Local::timelocal ((0x02ca+ 5559-0x1881),
(0x0043+ 8577-0x21c4),(0x020b+ 5469-0x175c),$3,($2-(0x112c+ 2605-0x1b58)),$1));my (
$wday,$yday,$isdst);(my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=
Common::NXTime::getLocalTimeFromTimestamp ($buildday_timestamp));($year+=
(0x1f48+ 1175-0x1c73));(my (@mon_list)=("\x4a\x61\x6e","\x46\x65\x62",
"\x4d\x61\x72","\x41\x70\x72","\x4d\x61\x79","\x4a\x75\x6e","\x4a\x75\x6c",
"\x41\x75\x67","\x53\x65\x70","\x4f\x63\x74","\x4e\x6f\x76","\x44\x65\x63"));(my (
@day_list)=("\x53\x75\x6e","\x4d\x6f\x6e","\x54\x75\x65","\x57\x65\x64",
"\x54\x68\x75","\x46\x72\x69","\x53\x61\x74"));(my $buildday_formated=((((((((((
($day_list[$wday]."\x20").$mon_list[$mon])."\x20").$mday)."\x20").sprintf (
"\x25\x30\x32\x64",$hour))."\x3a").sprintf ("\x25\x30\x32\x64",$min))."\x3a").
sprintf ("\x25\x30\x32\x64",$sec)).("\x20\x43\x45\x54\x20".$year)));(my $buildday
=$year);($buildday=($buildday.sprintf ("\x25\x30\x32\x64",($mon+
(0x2646+  56-0x267d)))));($buildday=($buildday.sprintf ("\x25\x30\x32\x64",$mday
)));return ($buildday_formated,$buildday);}sub convertToArray{(my (@licenseFile)
=@_);(my (@licencje)=());my ($tagON);my ($lic);(my $FoundLicense=
(0x23c7+  96-0x2427));foreach my $line (@licenseFile){if (($line=~ /^----- Begin subscription data -----(\r*)$/ )
){($lic=(""));($tagON=(0x0c24+ 4283-0x1cde));}if (($tagON==(0x06fc+ 6185-0x1f24)
)){($lic.=($line."\x0a"));}if (($line=~ /^----- End subscription data -----(\r*)$/ )
){if (($lic ne (""))){push (@licencje,$lic);}($tagON=(0x0a69+ 5037-0x1e16));(
$lic=(""));}}return (@licencje);}sub load_license_from_file{Logger::debug (((
"\x52\x65\x61\x64\x69\x6e\x67\x20\x6c\x69\x63\x65\x6e\x73\x65\x20\x77\x69\x74\x68\x20\x65\x66\x66\x65\x63\x74\x69\x76\x65\x20\x75\x69\x64\x20\x27"
.$>)."\x27\x2e"));(my $mode=Common::NXCore::NXFileMode (
$GLOBAL::PRODUCT_KEY_FILE));if ((defined ($mode)and (($mode&(0x1250+ 837-0x0596)
)ne (0x0862+ 7564-0x24ee)))){Logger::warning ((((
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27".
$GLOBAL::PRODUCT_KEY_FILE).
"\x27\x20\x68\x61\x73\x20\x77\x72\x6f\x6e\x67\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x2e"
).
"\x20\x43\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x61\x72\x65\x20\x30\x34\x30\x30\x2e"
));}(my $content=(""));(my $FILE=main::nxopen ($GLOBAL::PRODUCT_KEY_FILE,
$NXBits::O_RDONLY,(0x1991+ 2416-0x2301),{"\x45\x41\x43\x43\x45\x53",
"\x73\x69\x6c\x65\x6e\x74"}));if ($FILE){while (main::nxreadLine ($FILE,(\$_))){
($content.=$_);}main::nxclose ($FILE);}else{if (($>eq (0x0687+ 2874-0x11c1))){(my $errorNumber
=libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x61\x64\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$license)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x20\x27").$errorString).
"\x27\x2e"));Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x03c3+ 3117-0x0ff0));}(my (@command)=$GLOBAL::CommandNXexec);
push (@command,"\x2d\x2d\x6e\x6f\x64\x65\x6c\x69\x63\x65\x6e\x73\x65");(my (
@params)=());push (@params,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");(my (
$cmd_err,$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@params)));if (
$exit_value){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x61\x63\x63\x65\x73\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$GLOBAL::PRODUCT_KEY_FILE).
"\x27\x20\x74\x68\x72\x6f\x75\x67\x68\x20\x6e\x78\x65\x78\x65\x63\x2e"));
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x0891+ 5106-0x1c83));}else{Logger::debug (((((((
"\x28\x63\x6d\x64\x5f\x65\x72\x72\x2c\x20\x63\x6d\x64\x5f\x6f\x75\x74\x2c\x20\x65\x78\x69\x74\x5f\x76\x61\x6c\x75\x65\x29\x20\x28"
.$cmd_err)."\x2c\x20").$cmd_out)."\x2c\x20").$exit_value)."\x29\x2e"));($content
=$cmd_out);}}($content=Common::NXCore::extractLicenseBodyFromLicenseFile (
$content));return (split ( /\n/ ,$content,(0x109d+ 793-0x13b6)));}sub 
subscriptiondel{(my $subscriptionId=(shift (@_)||("")));my ($content);(my (
@licenseFile)=load_license_from_file ());(my (@licencje)=convertToArray (
@licenseFile));(my (@parsed_licenses)=convertArrayToLicArray (@licencje));(my $flag_found_subscription
=(0x0641+ 696-0x08f9));(my $tmpLicFile=($GLOBAL::PRODUCT_KEY_FILE.
"\x2e\x74\x6d\x70"));(my $FH=main::nxopen ($tmpLicFile,$NXBits::O_WRONLY,
(0x007a+ 5237-0x14ef)));if ((not (defined ($FH)))){(my $errorString=
libnxh::NXGetErrorString ());Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79"
,$tmpLicFile,$errorString);return;}foreach my $lic (@parsed_licenses){if (($$lic
{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}ne $subscriptionId)){
main::nxwrite ($FH,$$lic{"\x63\x6f\x6e\x74\x65\x6e\x74"});}else{(
$flag_found_subscription=(0x0cb6+ 1600-0x12f5));}}main::nxclose ($FH);if ((
$flag_found_subscription==(0x16fb+ 556-0x1927))){Common::NXMsg::error (
"\x65\x4e\x6f\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x41\x73\x73\x6f\x63\x69\x61\x74\x65\x64"
,$subscriptionId);unlink ($tmpLicFile);return;}(my (@command)=(
"\x2f\x62\x69\x6e\x2f\x63\x70",$tmpLicFile,$GLOBAL::PRODUCT_KEY_FILE));(my (@opt
)=());(my ($stderr,$stdout,$result_status)=run_command ((\@command),(\@opt)));if
 (($result_status==(0x10ad+  27-0x10c8))){Common::NXMsg::send_response (
"\x69\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x44\x65\x6c\x65\x74\x65\x64"
);}else{Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x43\x61\x6e\x6e\x6f\x74\x42\x65\x44\x65\x6c\x65\x74\x65\x64"
,$stderr);}return;}sub subscriptionadd{(my $sfile=(shift (@_)||("")));my (
$content);if (($sfile eq (""))){Common::NXMsg::error (
"\x65\x4e\x6f\x50\x61\x74\x68\x54\x6f\x4c\x69\x63\x65\x6e\x73\x65\x46\x69\x6c\x65"
);Common::NXMsg::error (
"\x65\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
);return ((0x25f4+  27-0x260f));}if ((not (Common::NXFile::fileExists ($sfile)))
){Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x46\x69\x6c\x65",$sfile);
Common::NXMsg::error ("\x65\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74",
$sfile);return ((0x0cdc+ 4991-0x205b));}(my $KEY_FD=main::nxopen ($sfile,
$NXBits::O_RDONLY,(0x1782+ 3173-0x23e7)));if ((not (defined ($KEY_FD)))){(my $error
=libnxh::NXGetError ());if ((Common::NXCore::ErrnoENOENT ()==$error)){
Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74"
,$sfile);return ((0x0513+ 1236-0x09e7));}else{Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
,$sfile);return ((0x059d+ 3974-0x1523));}}else{while (main::nxreadLine ($KEY_FD,
(\$_))){($content.=$_);}main::nxclose ($KEY_FD);}(my (@tmp)=split ( /\n/ ,
$content,(0x0259+ 1689-0x08f2)));(my (@licencje)=convertToArray (@tmp));(my (
@parsed_licenses)=convertArrayToLicArray (@licencje));if (($#parsed_licenses==(-
(0x0990+ 3539-0x1762)))){Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
,$sfile);Common::NXMsg::error (
"\x65\x49\x6e\x76\x61\x6c\x69\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e"
);return ((0x0f13+ 4184-0x1f6b));}(my $SUB_FD=main::nxopen (
$GLOBAL::PRODUCT_KEY_FILE,(($NXBits::O_WRONLY+$NXBits::O_APPEND)+
$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)+
$NXBits::OthersRead)));if ((not (defined ($SUB_FD)))){(my $errorString=
libnxh::NXGetErrorString ());Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x4c\x69\x63\x65\x6e\x73\x65\x46\x69\x6c\x65"
,$errorString);return ((0x1819+ 3183-0x2488));}main::nxwrite ($SUB_FD,$content);
main::nxclose ($SUB_FD);Common::NXMsg::send_response (
"\x69\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x31"
,$sfile);Common::NXMsg::send_response (
"\x69\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x32"
);return ((0x0380+ 5544-0x1928));}sub serverlist{(my (@licenseFile)=
load_license_from_file ());(my (@licencje)=convertToArray (@licenseFile));(my (
@parsed_licenses)=convertArrayToLicArray (@licencje));(my $flag_found_any_license
=(0x1a8a+ 2899-0x25dd));if (($#parsed_licenses==(-(0x12ed+ 1113-0x1745)))){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x1464+ 3196-0x20df));}foreach my $lic (@parsed_licenses){if ((
defined ($$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})and $$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})){($flag_found_any_license=
(0x2284+ 1124-0x26e7));Common::NXMsg::send_response (
"\x69\x53\x65\x72\x76\x65\x72\x4b\x65\x79",$$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"});($GLOBAL::NODE_ROOT=
$GLOBAL::NX_SYSTEM);(my $keyfile=((((((($GLOBAL::NODE_ROOT.
$GLOBAL::DIRECTORY_SLASH)."\x65\x74\x63").$GLOBAL::DIRECTORY_SLASH).
"\x6b\x65\x79\x73").$GLOBAL::DIRECTORY_SLASH).$$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}).
"\x2e\x6e\x6f\x64\x65\x2e\x69\x64\x5f\x64\x73\x61\x2e\x70\x75\x62"));if (
Common::NXFile::fileExists ($keyfile)){Common::NXMsg::send_response (
"\x69\x55\x73\x69\x6e\x67\x4b\x65\x79",$keyfile);}else{Common::NXMsg::error (
"\x65\x4e\x6f\x74\x48\x61\x76\x69\x6e\x67\x56\x61\x6c\x69\x64\x4b\x65\x79",$$lic
{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"});}}}if (($flag_found_any_license==
(0x0e09+ 363-0x0f74))){Common::NXMsg::error (
"\x65\x4e\x6f\x53\x65\x72\x76\x65\x72\x41\x73\x73\x6f\x63\x69\x61\x74\x65\x64");
}return;}return ((0x1e1b+ 1559-0x2431));
