############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXAutomaticRecordingNode::BEGIN{package NXAutomaticRecordingNode;no warnings
;require Common::NXInfo;do{
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x49\x6e\x66\x6f"->import};}package 
NXAutomaticRecordingNode;no warnings;((%startRequest)=());((%startedRecording)=
());((%states)=());((%transition)=());((%waitInSelect)=());($statesInitialized=
(0x0996+ 5559-0x1f4d));((%currentState)=());((%startWaitInSelect)=());((
%recordingStdout)=());((%recordingStdin)=());((%recordPid)=());((
%sigchldReceived)=());((%pingCounter)=());((%audioLoaded)=());((
%recordingSessionId)=());($pingTimeout=(0x0fd0+ 3259-0x1c81));($terminateTimeout
=(0x011c+ 5603-0x16e1));($defaultTerminateTimeout=(0x0527+ 4365-0x1616));(
$defaultTimeout=(0x038c+ 6342-0x1c16));($masterTerminateTimeout=
(0x14da+ 980-0x18a9));($killTimeout=(0x0464+ 5598-0x1a3d));$rootDirPath;sub 
checkAndHandleIfNeeded{if (($statesInitialized==(0x12b9+ 393-0x1442))){return;}
foreach my $sessionId (keys (%startedRecording)){run ($sessionId);}}sub 
shutdownTerminate{__changeTerminateTimeout ($masterTerminateTimeout);(my $startTerminatingTime
=Common::NXTime::getSecondsSinceEpoch ());foreach my $sessionId (keys (
%startedRecording)){__setNextState ($sessionId,
"\x73\x74\x6f\x70\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");}while (
%startedRecording){foreach my $sessionId (keys (%startedRecording)){run (
$sessionId);}if ((((($startTerminatingTime+$masterTerminateTimeout)+$killTimeout
)+(0x1338+ 5077-0x270c))<Common::NXTime::getSecondsSinceEpoch ())){foreach my $sessionId
 (keys (%startedRecording)){__emergencyCleanup ($sessionId);}return;}
__waitInSelect ();}}sub terminate{(my $sessionId=shift (@_));__stop ($sessionId)
;Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x72\x65\x63\x6f\x72\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$recordPid{$sessionId}).
"\x27\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20").$terminateTimeout).
"\x2e"));}sub setRecordPid{(my $sessionId=shift (@_));(my $pid=shift (@_));(
$recordPid{$sessionId}=$pid);NXSession2::setNodePidForSession (
$recordingSessionId{$sessionId},$pid);Logger::debug2 (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x6e\x6f\x64\x65\x20\x72\x65\x63\x6f\x72\x64\x20\x70\x69\x64\x3a\x20\x27"
.$pid)."\x27\x2e"));__runReniceScript ($pid);if ((__addHandleToMonitor (
$sessionId)==(-(0x0b0d+ 2075-0x1327)))){__emergencyCleanup ($sessionId);return;}
__addSigchldHandle ($pid);}sub automaticRecordingSigchldHandler{(my $pid=shift (
@_));(my $sessionId=__getSessionIdByPid ($pid));Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x73\x69\x67\x63\x68\x6c\x64\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20"
.$sessionId)."\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20").$pid)."\x2e"));(
$sigchldReceived{$sessionId}=$pid);if ((not (defined ($recordingStdout{
$sessionId})))){__cleanAfterRecord ($sessionId);}else{Logger::debug (
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x73\x69\x67\x63\x68\x6c\x64\x2c\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6c\x6f\x73\x65\x20\x73\x6f\x63\x6b\x65\x74\x2e"
);}}sub startRecordSessionById{(my $sessionId=shift (@_));if (($startRequest{
$sessionId}ne (""))){Logger::debug (
"\x53\x6b\x69\x70\x20\x73\x74\x61\x72\x74\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x6e\x6f\x64\x65\x2c\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);return;}if ((__initialize ()==(0x0ecc+ 105-0x0f35))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
.$sessionId)."\x2e"));return;}push (@startedRecording,$sessionId);
__setCurrentState ($sessionId,
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
);__setNextState ($sessionId,
"\x73\x74\x61\x72\x74\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");(my $mainSessionId=
NXSession2::getMainSessionIdBySessionId ($sessionId));($startRequest{$sessionId}
=$mainSessionId);if ((not (defined ($startedRecording{$mainSessionId})))){(
$startedRecording{$mainSessionId}=[$sessionId]);__setCurrentState (
$mainSessionId,
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
);__setNextState ($mainSessionId,
"\x73\x74\x61\x72\x74\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");}else{Logger::debug 
(((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
.$mainSessionId).
"\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));push (@{$startedRecording{$mainSessionId};},$sessionId);}}sub stop{(my $sessionId
=shift (@_));__setNextState ($sessionId,
"\x73\x74\x6f\x70\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");}sub 
stopRecordSessionById{(my $sessionId=shift (@_));if ((not (defined (
$startRequest{$sessionId})))){Logger::debug (
"\x53\x6b\x69\x70\x20\x73\x74\x6f\x70\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x6e\x6f\x64\x65\x2c\x20\x6e\x65\x76\x65\x72\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
);return;}(my $mainSessionId=$startRequest{$sessionId});delete ($startRequest{
$sessionId});(my (@list)=());(my $empty=(0x02a3+ 3279-0x0f71));foreach my $id (@
{$startedRecording{$mainSessionId};}){if (($id ne $sessionId)){push (@list,$id);
($empty=(0x0675+ 4391-0x179c));}}Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x27"
.$empty).
"\x27\x20\x73\x74\x6f\x70\x52\x65\x63\x6f\x72\x64\x53\x65\x73\x73\x69\x6f\x6e\x42\x79\x49\x64\x3a\x20"
).$sessionId)."\x2e"));if ($empty){Logger::debug (((
"\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x20\x61\x6e\x79\x20\x75\x73\x65\x72\x20\x77\x68\x69\x63\x68\x20\x73\x68\x6f\x75\x6c\x64\x20\x62\x65\x20\x72\x65\x63\x6f\x72\x64\x65\x64\x2c\x20\x73\x74\x6f\x70\x20\x72\x65\x63\x6f\x72\x64\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
.$mainSessionId)."\x2e"));stop ($mainSessionId);}else{Logger::debug (((((
"\x53\x74\x69\x6c\x6c\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x20\x75\x73\x65\x72\x73\x3a\x20"
.join ($",@list)).
"\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
).$mainSessionId)."\x2e"));(@{$startedRecording{$mainSessionId};}=@list);}}sub 
isAutomaticRecordingingSocket{(my $fh=shift (@_));if (defined ($recordingStdout{
$fh})){return ((0x0e72+ 1603-0x14b4));}return ((0x11d9+ 1844-0x190d));}sub 
handleMessage{(my $fh=shift (@_));if (defined ($recordingStdout{$fh})){my (
$read_buf);(my $bytes_read=main::nxread ($fh,(\$read_buf),(0x217d+ 989-0x155a)))
;(my $sessionId=$recordingStdout{$fh});Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x67\x6f\x74\x20\x27"
.$bytes_read)."\x27\x20\x62\x79\x74\x65\x73\x20\x27").$read_buf).
"\x27\x20\x66\x72\x6f\x6d\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x6e\x6f\x64\x65\x2e"
));if (($bytes_read==(0x1263+ 678-0x1509))){__removeMonitorHandle ($fh);delete (
$recordingStdout{$fh});if ($sigchldReceived{$sessionId}){if (defined (
$recordingSessionId{$sessionId})){__cleanAfterRecord ($sessionId);}else{
Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x27"
.$sessionId).
"\x27\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x68\x61\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x62\x65\x65\x6e\x20\x63\x6c\x65\x61\x6e\x65\x64\x2e"
));}}else{Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x27"
.$sessionId).
"\x27\x20\x63\x6c\x6f\x73\x65\x64\x2c\x20\x77\x61\x69\x74\x20\x66\x6f\x72\x20").
$recordPid{$sessionId})."\x20\x73\x69\x67\x63\x68\x6c\x64\x2e"));}}else{
__handleMessageFromNodeAutomaticRecording ($sessionId,$read_buf);}}}sub 
__getStdoutBySessionID{(my $sessionId=shift (@_));foreach my $fh (keys (
%recordingStdout)){if (($recordingStdout{$fh}eq $sessionId)){return ($fh);}}
return ((-(0x0ddd+ 1507-0x13bf)));}sub __getSessionIdByPid{(my $pid=shift (@_));
foreach my $id (keys (%recordPid)){if (($recordPid{$id}eq $pid)){return ($id);}}
return ((-(0x07b1+ 4447-0x190f)));}sub __getTmpRecordingPath{(my $sessionId=
shift (@_));return (((((((NXNodeConfiguration::getNXRecordingDirectory ().
$GLOBAL::DIRECTORY_SLASH)."\x74\x6d\x70").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x63\x6f\x72\x64").$GLOBAL::DIRECTORY_SLASH).$sessionId));}sub 
__getFinishedRecordingPath{(my $sessionId=shift (@_));(my ($username,$createTime
,$display)=NXSession2::getParametersForAutomaticRecording ($sessionId));if ((
$username=~ /\\/ )){($username=~ s/.*\\// );}if (($username=~ /\@/ )){($username
=~ s/.*\@// );}if (($username=~ /\// )){($username=~ s/.*\/// );}($createTime=
Common::NXTime::convertLocalTimeFromTimestampToHumanReadableString ($createTime)
);(my $path=((((((($username."\x2d").$display)."\x2d").$createTime)."\x2d").
Common::NXTime::convertLocalTimeFromTimestampToHumanReadableString (
Common::NXTime::getSecondsSinceEpoch ()))."\x2e\x6e\x78\x72"));($path=~ s/ /_/g )
;($path=~ s/:/-/g );($path=((NXNodeConfiguration::getNXRecordingDirectory ().
$GLOBAL::DIRECTORY_SLASH).$path));return ($path,$username);}sub __waitInSelect{(my $selector
="\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new
);(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);(my (@ready)=$selector->can_read (($masterTerminateTimeout *
(0x0c9f+ 6551-0x224e))));foreach my $fh (@ready){if (
isAutomaticRecordingingSocket ($fh)){handleMessage ($fh);}}}sub 
__cleanAfterRecord{(my $sessionId=shift (@_));(my $exitcode=
Common::NXProcess::getExitValue ($recordPid{$sessionId}));(my $oldName=
__getTmpRecordingPath ($sessionId));(my ($newName,$username)=
__getFinishedRecordingPath ($sessionId));if ((not (Common::NXFile::fileExists (
$oldName)))){if (defined ($recordingSessionId{$sessionId})){Logger::warning (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x52\x65\x63\x6f\x72\x64\x20\x66\x69\x6c\x65\x20\x27"
.$oldName)."\x27\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));}else{
Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x27"
.$sessionId).
"\x27\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x68\x61\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x62\x65\x65\x6e\x20\x63\x6c\x65\x61\x6e\x65\x64\x2e"
));return;}}else{if ((libnxh::NXFileRename ($oldName,$newName)!=
(0x109d+ 2260-0x1971))){Logger::warning ((((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20\x27"
.$oldName)."\x27\x20\x74\x6f\x20\x27").$newName).
"\x27\x20\x65\x72\x72\x6f\x72\x20\x69\x73\x3a\x20").libnxh::NXGetErrorString ())
);if ((libnxh::NXFileRemove ($oldName)!=(0x0ec2+ 1590-0x14f8))){Logger::warning 
((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20\x27"
.$oldName)."\x27\x2e\x20").libnxh::NXGetErrorString ()));}}my ($errorName,
$errorCode);if ((Common::NXFile::setPermissionsReadWriteForUserAndAdmin (
$newName,$username,(\$errorName),(\$errorCode))==(-(0x0450+ 1761-0x0b30)))){
Logger::warning (((((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20"
.$username).
"\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
).$errorCode)."\x3a\x20").$errorName)."\x2e"));}}Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x4e\x6f\x64\x65\x20\x72\x65\x63\x6f\x72\x64\x20\x65\x6e\x64\x20\x77\x69\x74\x68\x20\x63\x6f\x64\x65\x3a\x20"
.$exitcode)."\x2e"));if (($exitcode!=(0x03dc+ 3617-0x11fd))){__emergencyCleanup 
($sessionId);}else{__clean ($sessionId);}}sub __terminateTimeoutReached{(my $sessionId
=shift (@_));Logger::warning ((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x50\x72\x6f\x63\x65\x73\x73\x20\x77\x61\x73\x20\x6e\x6f\x74\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x77\x69\x74\x68\x69\x6e\x20\x65\x78\x70\x65\x63\x74\x65\x64\x20\x74\x69\x6d\x65\x20\x6f\x66\x20"
.$terminateTimeout)."\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20").((
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x20\x74\x68\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$recordPid{$sessionId})."\x2e")));__setNextState ($sessionId,
"\x6b\x69\x6c\x6c\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");}sub __killNodeRecord{(my $sessionId
=shift (@_));Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x6b\x69\x6c\x6c\x69\x6e\x67\x20\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$recordPid{$sessionId})."\x27\x2e"));if (__isRunning ($sessionId)){if ((
Common::NXProcess::sigkill ($recordPid{$sessionId})==(0x0ea2+ 1010-0x1294))){
Logger::warning (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x50\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x67\x20\x70\x69\x64\x3a\x20"
.$recordPid{$sessionId}).
"\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x6b\x69\x6c\x6c\x65\x64\x2e"));}
else{Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x66\x69\x6e\x69\x73\x68\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$recordPid{$sessionId})."\x27\x2e"));}__setNextState ($sessionId,
"\x6b\x69\x6c\x6c\x69\x6e\x67");}else{Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x5b"
.$recordPid{$sessionId}).
"\x5d\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67"));($recordPid
{$sessionId}=(0x0153+ 279-0x026a));__setNextState ($sessionId,
"\x6e\x6f\x64\x65\x49\x73\x4e\x6f\x74\x52\x75\x6e\x6e\x69\x6e\x67");}}sub 
__start{(my $sessionId=shift (@_));if ((__runNodeAutomaticRecording ($sessionId)
==(-(0x0f44+ 3716-0x1dc7)))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x6e\x6f\x64\x65\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20"
.$sessionId)."\x2e"));return;}__loadAudio ($sessionId);
__sendToAutomaticRecording ($sessionId,"\x73\x68\x65\x6c\x6c\x0a");
__setScreenBlanking ($sessionId);__setNextState ($sessionId,
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74");}sub __stop{(my $sessionId=shift
 (@_));__sendToAutomaticRecording ($sessionId,(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_STOP_LOCAL_RECORD)."\x0a"));__setNextState ($sessionId,
"\x74\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67");}sub __clean{(my $sessionId=
shift (@_));__unloadAudio ($sessionId);__cleanVariables ($sessionId);}sub 
__killTimeoutReached{(my $sessionId=shift (@_));Logger::warning (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x4b\x69\x6c\x6c\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x72\x65\x61\x63\x68\x65\x64\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20"
.$sessionId).
"\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20").
$recordPid{$sessionId})."\x2e"));}sub __emergencyCleanup{(my $sessionId=shift (
@_));if (__isRunning ($sessionId)){if ((Common::NXProcess::sigkill ($recordPid{
$sessionId})==(0x077f+ 8033-0x26e0))){Logger::warning (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6b\x69\x6c\x6c\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20"
.$sessionId).
"\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20").
$recordPid{$sessionId})."\x2e"));}else{Logger::debug2 (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x66\x69\x6e\x69\x73\x68\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$recordPid{$sessionId})."\x27\x2e"));}}__cleanFiles ($recordingSessionId{
$sessionId});__unloadAudio ($sessionId);__cleanVariables ($sessionId);}sub 
__handleMessageFromNodeAutomaticRecording{(my $sessionId=shift (@_));(my $buffer
=shift (@_));Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x50\x61\x72\x73\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$buffer).
"\x27\x20\x66\x72\x6f\x6d\x20\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x27"
).$sessionId)."\x27\x20\x6e\x6f\x64\x65\x2e"));if (($buffer=~ s/NX> $GLOBAL::MSG_NODE_SHELL_PROMPT done.\n// )
){if ((not (defined ($commandSentFlag{$sessionId})))){__sendToAutomaticRecording
 ($sessionId,
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x0a\x0a");(
$commandSentFlag{$sessionId}=(0x075a+ 2900-0x12ad));}else{
__sendInitializingMessages ($sessionId);}}if (($buffer=~ s/NX> $GLOBAL::MSG_PING_LOCAL_RECORD Pong\n//g )
){Logger::debug (
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x50\x69\x6e\x67\x20\x72\x65\x70\x6c\x61\x79\x2e"
);($pingCounter{$sessionId}=(0x1559+ 2162-0x1dcb));}if (($buffer=~ s/NX> $GLOBAL::MSG_ERROR_LOCAL_RECORD (.*)\n//g )
){Logger::debug (((
"\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x6e\x6f\x64\x65\x20\x72\x65\x70\x6f\x72\x74\x20\x65\x72\x72\x6f\x72\x20"
.$1)."\x2e"));}if (($buffer=~ s/NX> $GLOBAL::MSG_START_LOCAL_RECORD 1\n//g )){if
 ((NXSession2::getNumberOfConnectedSesions ($sessionId)>(0x049a+ 2861-0x0fc6))){
(my $message=NXMsg::get_text (
"\x69\x47\x55\x49\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x53\x65\x73\x73\x69\x6f\x6e\x57\x69\x6c\x6c\x42\x65\x52\x65\x63\x6f\x72\x64\x65\x64"
));(my $message_url=(($GLOBAL::MSG_MESSAGE_TO_SESSION."\x20").main::urlencode (
$message)));(my $send_error=main::send_command_to_server ($sessionId,
$message_url));Logger::debug (((((
"\x53\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27".$message).
"\x27\x20\x72\x65\x73\x6f\x75\x6c\x74\x3a\x20").$send_error)."\x2e"));}
__setNextState ($sessionId,"\x6e\x6f\x64\x65\x53\x74\x61\x72\x74\x65\x64");}if (
($buffer=~ /NX> $GLOBAL::MSG_AGENTM_DISPLAY_COOKIE display=(.*),cookie=(.*) \n/ )
){NXSession2::setDisplayAndCookie ($recordingSessionId{$sessionId},$1,$2);}}sub 
__createDescriptorsPair{my ($in);my ($out);my ($error);if (
Common::NXCore::nxPipeCreateBiWithError ((\$in),(\$out),(\$error))){
Logger::debug2 (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x72\x65\x61\x74\x65\x64\x20\x70\x61\x69\x72\x20\x6f\x66\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x69\x6e\x20\x27"
.$in)."\x27\x20\x6f\x75\x74\x20\x27").$out)."\x27\x2e"));}else{Logger::warning (
((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x70\x61\x69\x72\x20\x6f\x66\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20"
.$error)."\x2e"));return ((-(0x12fb+ 2301-0x1bf7)));}if (defined (
Common::NXCore::nxDescriptorInheritable ($out,(0x11a6+ 2690-0x1c27)))){
Logger::debug2 (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x53\x65\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x27"
.$out)."\x27\x20\x61\x73\x20\x69\x6e\x68\x65\x72\x69\x74\x61\x62\x6c\x65\x2e"));
}else{($error=libnxh::NXGetErrorString ());Logger::warning (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x73\x65\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x27"
.$out)."\x27\x20\x61\x73\x20\x69\x6e\x68\x65\x72\x69\x74\x61\x62\x6c\x65\x20").
$error)."\x2e"));return ((-(0x1ad3+ 3032-0x26aa)));}return ($in,$out);}sub 
__sendInitializingMessages{(my $sessionId=shift (@_));(my $mainSessionId=
NXSession2::getMainSessionIdBySessionId ($sessionId));(my ($display,$cookie)=
NXSession2::getAgentMDisplayAndCookieBySessionId ($mainSessionId));(my $path=
__getTmpRecordingPath ($sessionId));($path=main::urlencode ($path));
Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x73\x65\x6e\x64\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x73\x3a\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x27\x2a\x2a\x2a\x2a\x2a\x2a\x2a\x27\x20\x6d\x61\x73\x65\x72\x20\x64\x69\x73\x70\x6c\x61\x79\x20\x69\x64\x20\x27"
.$display)."\x27\x2e"));__sendToAutomaticRecording ($sessionId,((((
"\x4e\x58\x3e\x20".$GLOBAL::MSG_AGENTM_COOKIE)."\x20").$cookie)."\x0a"));
__sendToAutomaticRecording ($sessionId,(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_AGENTM_DISPLAY)."\x20").$display)."\x0a"));
__sendToAutomaticRecording ($sessionId,(((("\x4e\x58\x3e\x20".
$GLOBAL::MSG_START_LOCAL_RECORD)."\x20").$path)."\x0a"));
__sendToAutomaticRecording ($sessionId,$message);}sub __getSessionDirPath{(my $sessionId
=shift (@_));return (((($rootDirPath.$GLOBAL::DIRECTORY_SLASH)."\x43\x2d").
__getLongSessionId ($sessionId)));}sub __getSessionFailedDir{(my $sessionId=
shift (@_));return (((($rootDirPath.$GLOBAL::DIRECTORY_SLASH)."\x46\x2d\x43\x2d"
).__getLongSessionId ($sessionId)));}sub __cleanFiles{(my $sessionId=shift (@_))
;(my $dirToChange=__getSessionDirPath ($sessionId));if (-d ($dirToChange)){(my $renameType
=__getSessionFailedDir ($sessionId));Logger::debug ((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x53\x65\x73\x73\x69\x6f\x6e\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x64\x6f\x6e\x27\x74\x20\x63\x6c\x65\x61\x72\x65\x64\x20"
.(("\x64\x69\x72\x20\x27".$dirToChange).
"\x27\x20\x61\x66\x74\x65\x72\x20\x6c\x6f\x63\x61\x6c\x20\x72\x65\x63\x6f\x72\x64\x20\x65\x78\x69\x73\x74\x2e"
)));if ((libnxh::NXFileRename ($dirToChange,$renameType)==(0x1c19+ 2605-0x2646))
){Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x52\x65\x6e\x61\x6d\x65\x64\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27"
.$dirToChange)."\x27\x20\x74\x6f\x20\x27").$renameType)."\x27\x2e"));}else{
Logger::warning (((((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20\x27"
.$dirToChange)."\x27\x20\x74\x6f\x20\x27").$renameType)."\x27\x20\x2d\x20\x27").
libnxh::NXGetErrorString ())."\x27\x2e"));}}}sub __getLongSessionId{(my $sessionId
=shift (@_));(my ($display,$cookie)=
NXSession2::getDisplayAndLocalCookieBySessionId ($sessionId));return (((((
Common::NXInfo::getHostInfo ()."\x2d").$display)."\x2d").$sessionId));}sub 
__sendToAutomaticRecording{(my $sessionId=shift (@_));(my $msg=shift (@_));my (
$bytesWritten);($bytesWritten=main::nxwrite ($recordingStdin{$sessionId},$msg));
Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x53\x65\x6e\x74\x20\x27"
.$msg)."\x27\x20\x62\x79\x74\x65\x73\x20\x27").$bytesWritten)."\x27\x2e"));}sub 
__addHandleToMonitor{(my $sessionId=shift (@_));(my $fh=__getStdoutBySessionID (
$sessionId));if (($fh==(-(0x1093+ 430-0x1240)))){Logger::warning (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x46\x44\x20\x66\x6f\x72\x20\x72\x65\x63\x6f\x72\x69\x6e\x67\x20\x73\x65\x73\x73\x69\x6f\x6e\x20"
.$sessionId)."\x2e"));}Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x61\x64\x64\x69\x6e\x67\x20\x68\x61\x6e\x64\x6c\x65\x20\x46\x44\x23"
.$fh)."\x2e"));Common::NXSelector::addToGlobalSelector ($fh,((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x20\x27"
.$sessionId)."\x27"),
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x3a\x68\x61\x6e\x64\x6c\x65\x4d\x65\x73\x73\x61\x67\x65"
);}sub __removeMonitorHandle{(my $handler=shift (@_));Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x72\x65\x6d\x6f\x76\x69\x6e\x67\x20\x68\x61\x6e\x64\x6c\x65\x20\x46\x44\x23"
.$handler)."\x2e"));Common::NXSelector::removeFromGlobalSelector ($handler);
main::nxclose ($handler);}sub __addSigchldHandle{(my $processPid=shift (@_));
Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x41\x64\x64\x69\x6e\x67\x20\x73\x69\x67\x63\x68\x6c\x64\x20\x68\x61\x6e\x64\x6c\x65\x20\x66\x6f\x72\x20\x70\x69\x64\x20\x27"
.$processPid)."\x27\x2e"));Common::NXProcess::setCallbackSIGCHLD ($processPid,(
\&automaticRecordingSigchldHandler));}sub __unloadAudio{(my $sessionId=shift (@_
));if (($audioLoaded{$sessionId}==(0x126d+ 5256-0x26f4))){Logger::debug (
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x55\x6e\x6c\x6f\x61\x64\x64\x69\x6e\x67\x20\x61\x75\x64\x69\x6f\x2e"
);(my $message=($GLOBAL::MSG_REQUEST_SET_AUDIO.
"\x20\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x73\x74\x6f\x70\x70\x65\x64"));
Logger::debug2 (((
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x6f\x64\x65\x3a\x20\x27"
.$message)."\x27\x2e"));if ((__sendMessageToMainServerBySessionId ($sessionId,
$message)==(-(0x0534+ 8346-0x25cd)))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x75\x6e\x6c\x6f\x61\x64\x20\x61\x75\x64\x69\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);}delete ($audioLoaded{$sessionId});}}sub __loadAudio{(my $sessionId=shift (@_)
);if (($audioLoaded{$sessionId}==(0x03dd+ 7974-0x2303))){(my ($type,$error)=
NXSession2::getTypeBySessionId ($sessionId));if (
Common::NXSessionType::isNotPhysical ($type)){Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x53\x6b\x69\x70\x20\x6c\x6f\x61\x64\x69\x6e\x67\x20\x61\x75\x64\x69\x6f\x20\x66\x6f\x72\x20\x76\x69\x72\x74\x75\x61\x6c\x20\x73\x65\x73\x69\x73\x6f\x6e\x3a\x20\x27"
.$sessionId)."\x27\x2e"));return;}Logger::debug (
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x4c\x6f\x61\x64\x69\x6e\x67\x20\x61\x75\x64\x69\x6f\x2e"
);(my $message=($GLOBAL::MSG_REQUEST_SET_AUDIO.
"\x20\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"));
Logger::debug2 (((
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x6f\x64\x65\x3a\x20\x27"
.$message)."\x27\x2e"));if ((__sendMessageToMainServerBySessionId ($sessionId,
$message)==(-(0x0ab0+ 6960-0x25df)))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6c\x6f\x61\x64\x20\x61\x75\x64\x69\x6f\x20\x6d\x65\x73\x73\x61\x67\x65\x2e"
);}($audioLoaded{$sessionId}=(0x0b63+ 1366-0x10b8));}}sub 
__sendMessageToMainServerBySessionId{(my $sessionId=shift (@_));(my $command=
shift (@_));($sessionId=NXSession2::getMainSessionIdBySessionId ($sessionId));(my (
$cookie,$port)=NXSession2::getCookieAndPortForSessionId ($sessionId));if (($port
==(0x1e2d+ 1300-0x2341))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x73\x65\x72\x76\x65\x72\x27\x73\x20"
.$sessionId)."\x20\x70\x6f\x72\x74\x2e"));return ((-(0x0843+ 5629-0x1e3f)));}if 
(($cookie eq (""))){Logger::warning (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x73\x65\x72\x76\x65\x72\x27\x73\x20"
.$sessionId)."\x20\x63\x6f\x6f\x6b\x69\x65\x2e"));return ((-
(0x146a+ 1769-0x1b52)));}Logger::debug (((((
"\x53\x65\x73\x73\x69\x6f\x6e\x3a\x20".$sessionId).
"\x20\x67\x6f\x74\x20\x70\x6f\x72\x74\x3a\x20").$port).
"\x20\x61\x6e\x64\x20\x63\x6f\x6f\x6b\x69\x65\x3a\x20\x2a\x2a\x2a\x2a\x2a\x2a"))
;(my $message=(((("\x4e\x58\x3e\x20".$cookie)."\x20").$command)."\x0a"));(my $m_length
=length ($message));(my $sock=main::nxConnectLocal ($port));if (($sock!=(-
(0x0da5+ 3025-0x1975)))){if ((main::nxwrite ($sock,$message,$m_length)==(-
(0x1ce3+ 918-0x2078)))){Logger::warning ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$command)."\x3a\x20").libnxh::NXGetErrorString ()));return ((-
(0x0260+ 8429-0x234c)));}else{Logger::debug (((((
"\x4d\x65\x73\x73\x61\x67\x65\x20".$command).
"\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x73\x65\x72\x76\x65\x72\x20").$sessionId).
"\x2e"));}}else{Logger::warning ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x70\x6f\x72\x74\x3a\x20"
.$port));return ((-(0x1276+ 729-0x154e)));}main::nxclose ($sock);}sub 
__cleanVariables{(my $sessionId=shift (@_));Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x63\x6c\x65\x61\x6e\x69\x6e\x67\x20\x76\x61\x72\x69\x61\x62\x6c\x65\x73\x20\x27"
.$sessionId)."\x27\x2e"));main::nxclose ($recordingStdin{$sessionId});(my (
$display,$nodeHost,$nodePort)=NXSession2::getDisplayAndNodeBySessionId (
$recordingSessionId{$sessionId}));NXSession2::moveSessionFile (
$recordingSessionId{$sessionId});(my $node=(($nodeHost."\x3a").$nodePort));
foreach my $id (@{$startedRecording{$sessionId};}){delete ($startRequest{$id});}
delete ($currentState{$sessionId});delete ($startWaitInSelect{$sessionId});
delete ($recordingStdin{$sessionId});delete ($sigchldReceived{$sessionId});
delete ($recordPid{$sessionId});delete ($pingCounter{$sessionId});delete (
$recordingSessionId{$sessionId});delete ($startedRecording{$sessionId});delete (
$commandSentFlag{$sessionId});__resetScreenBlanking ($sessionId);}sub 
__runNodeAutomaticRecording{(my $sessionId=shift (@_));(my ($fhIn,$fhOut)=
__createDescriptorsPair ());if (($fhIn==(-(0x12c2+ 1219-0x1784)))){
Logger::warning (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
.$sessionId)."\x2e"));__emergencyCleanup ($sessionId);return ((-
(0x02ed+ 9169-0x26bd)));}(my ($fhChildInRead,$fhChildInWrite)=
__createDescriptorsPair ());if (($fhChildInRead==(-(0x16d4+ 2717-0x2170)))){
Logger::warning (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x73\x65\x73\x73\x69\x6f\x6e\x3a\x20"
.$sessionId)."\x2e"));main::nxclose ($fhIn);main::nxclose ($fhOut);
__emergencyCleanup ($sessionId);return ((-(0x02cc+ 8687-0x24ba)));}(my $setInheritableReturn
=Common::NXCore::nxDescriptorInheritable ($fhIn,(0x14e2+ 3792-0x23b1)));(
$setInheritableReturn=Common::NXCore::nxDescriptorInheritable ($fhChildInRead,
(0x02d6+ 165-0x037a)));($recordingStdout{$fhIn}=$sessionId);($recordingStdin{
$sessionId}=$fhChildInRead);(my (@command)=
__getNodeAutomaticRecordingPlatformDependantCommand ());if ((not (@command))){
Logger::warning (
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x74\x6f\x20\x73\x74\x61\x72\x74\x20\x6e\x6f\x64\x65\x2e"
);__emergencyCleanup ($sessionId);return ((-(0x03dd+ 2903-0x0f33)));}(my (
%sessionParameters)=__prepareSessionParameters ($sessionId));
NXSession2::createRecordingSession ((\%sessionParameters));(my (@parameters)=
__getNodeAutomaticRecordingPlatformDependantParameters ($fhChildInWrite,$fhOut,
$sessionId));main::nxRunCommand ((\@command),(\@parameters));}sub 
__prepareSessionParameters{(my $sessionId=shift (@_));(my (%sessionParameters)=
());(my $mainSessionId=NXSession2::getMainSessionIdBySessionId ($sessionId));(
$sessionParameters{"\x4d\x61\x69\x6e\x53\x65\x73\x73\x69\x6f\x6e"}=
$mainSessionId);($sessionParameters{
"\x64\x65\x73\x6b\x74\x6f\x70\x4f\x77\x6e\x65\x72"}="\x6e\x78");(
$sessionParameters{"\x73\x65\x73\x73\x69\x6f\x6e\x49\x64"}=main::get_unique_id 
());($recordingSessionId{$sessionId}=$sessionParameters{
"\x73\x65\x73\x73\x69\x6f\x6e\x49\x64"});(my ($nodeHost,$nodePort)=
NXSession2::getNodeBySessionId ($sessionId));($sessionParameters{
"\x6e\x6f\x64\x65\x48\x6f\x73\x74"}=$nodeHost);($sessionParameters{
"\x6e\x6f\x64\x65\x50\x6f\x72\x74"}=$nodePort);return (%sessionParameters);}sub 
__getNodeAutomaticRecordingPlatformDependantCommand{(my (@command)=());(my $NodeBin
=$GLOBAL::CommandNXNode);push (@command,$NodeBin);return (@command);}sub 
__getNodeAutomaticRecordingPlatformDependantParameters{(my $fdIn=shift (@_));(my $fdOut
=shift (@_));(my $sessionId=shift (@_));(my (@parameters)=());(my ($cookie,
$display)=NXSession2::getMainSessionCookieAndDisplayBySessionId ($sessionId));
push (@parameters,"\x75\x73\x65\x20\x61\x73\x20\x73\x74\x64\x69\x6e",$fdIn);push
 (@parameters,"\x75\x73\x65\x20\x61\x73\x20\x73\x74\x64\x6f\x75\x74",$fdOut);
push (@parameters,
"\x6c\x65\x61\x76\x65\x20\x73\x74\x64\x69\x6e\x20\x6f\x70\x65\x6e");push (
@parameters,
"\x6c\x65\x61\x76\x65\x20\x73\x74\x64\x6f\x75\x74\x20\x6f\x70\x65\x6e");push (
@parameters,"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");push (@parameters,
"\x73\x65\x74\x20\x65\x6e\x76",("\x53\x79\x73\x74\x65\x6d\x52\x6f\x6f\x74\x3d".
$ENV{"\x53\x79\x73\x74\x65\x6d\x52\x6f\x6f\x74"}));push (@parameters,
"\x73\x65\x74\x20\x65\x6e\x76",("\x44\x49\x53\x50\x4c\x41\x59\x3d\x3a".$display)
);push (@parameters,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".$GLOBAL::NODE_ROOT));push (
@parameters,"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x44\x49\x52\x3d".
$GLOBAL::NODE_ROOT));push (@parameters,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x52\x4f\x4f\x54\x3d".NXPaths::get_user_nx_dir ()));push (
@parameters,"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x48\x4f\x4d\x45\x3d".
NXPaths::get_user_nx_dir ()));push (@parameters,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".Common::NXPaths::getUserRealHomeDirectoryByEffectiveUser 
()));push (@parameters,"\x73\x65\x74\x20\x65\x6e\x76",("\x50\x41\x54\x48\x3d".
$ENV{"\x50\x41\x54\x48"}));push (@parameters,
"\x63\x6c\x6f\x73\x65\x41\x66\x74\x65\x72\x52\x75\x6e",$fdOut);push (@parameters
,"\x63\x6c\x6f\x73\x65\x41\x66\x74\x65\x72\x52\x75\x6e",$fdIn);push (@parameters
,"\x61\x6e\x64\x20\x63\x61\x6c\x6c\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e",
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x3a\x73\x65\x74\x52\x65\x63\x6f\x72\x64\x50\x69\x64"
,$sessionId);return (@parameters);}sub __sendPing{(my $sessionId=shift (@_));if 
(($pingCounter{$sessionId}>(0x11a7+ 744-0x148c))){Logger::warning ((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x50\x69\x6e\x67\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x67\x65\x74\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20"
.$pingCounter{$sessionId})."\x20\x74\x69\x6d\x65\x73\x2e\x20").((
"\x53\x65\x6e\x64\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x20\x74\x68\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$recordPid{$sessionId})."\x2e")));__setNextState ($sessionId,
"\x6b\x69\x6c\x6c\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");}else{($pingCounter{
$sessionId}+=(0x0ed3+ 1525-0x14c7));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_PING_LOCAL_RECORD)."\x20\x50\x69\x6e\x67\x0a"));
__sendToAutomaticRecording ($sessionId,$message);__setNextState ($sessionId,
"\x70\x69\x6e\x67\x53\x65\x6e\x74");}}sub __isRunning{(my $sessionId=shift (@_))
;if ($recordPid{$sessionId}){if (Common::NXProcess::isProcessRunning ($recordPid
{$sessionId})){return ((0x05df+ 2804-0x10d2));}Logger::debug (((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$recordPid{$sessionId}).
"\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));}return (
(0x0d08+ 1329-0x1239));}sub run{(my $sessionId=shift (@_));Logger::debug ((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x3a\x20"
.__getCurrentState ($sessionId)));while (__isReady ($sessionId)){
__handleCurrentState ($sessionId);}}sub getTimeout{(my $sessionId=shift (@_));(my $currentState
=__getCurrentState ($sessionId));if (defined ($waitInSelect{$currentState})){
return ($waitInSelect{$currentState});}return ("\x69\x6e\x66");}sub __initialize
{if (($statesInitialized==(0x1489+ 4172-0x24d5))){__addState (
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x5f\x5f\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
);__addTransition (
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x73\x74\x61\x72\x74\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");__addTransition (
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x69\x6e\x69\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x6e\x6f\x64\x65\x49\x73\x4e\x6f\x74\x52\x75\x6e\x6e\x69\x6e\x67");__addState 
(
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x5f\x5f\x73\x74\x61\x72\x74");__addTransition (
"\x73\x74\x61\x72\x74\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74");__addState (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x5f\x5f\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x52\x65\x63\x6f\x72\x64"
);__setInSelect (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,$defaultTimeout);__addTransition (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,"\x6e\x6f\x64\x65\x53\x74\x61\x72\x74\x65\x64");__addTransition (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x54\x6f\x43\x6c\x6f\x73\x65"
,"\x73\x74\x6f\x70\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");__addTransition (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x74\x69\x6d\x65\x4f\x75\x74");__addState (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x54\x6f\x43\x6c\x6f\x73\x65"
,
"\x5f\x5f\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x52\x65\x63\x6f\x72\x64"
);__setInSelect (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x54\x6f\x43\x6c\x6f\x73\x65"
,$defaultTimeout);__addTransition (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x54\x6f\x43\x6c\x6f\x73\x65"
,
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x6e\x6f\x64\x65\x53\x74\x61\x72\x74\x65\x64");__addTransition (
"\x77\x61\x69\x74\x54\x6f\x53\x74\x61\x72\x74\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x54\x6f\x43\x6c\x6f\x73\x65"
,
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x74\x69\x6d\x65\x4f\x75\x74");__addState (
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,
"\x5f\x5f\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x53\x74\x61\x72\x74\x65\x64"
);__setInSelect (
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,$pingTimeout);__addTransition (
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x73\x74\x6f\x70\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");__addTransition (
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,
"\x73\x65\x6e\x64\x50\x69\x6e\x67\x4d\x65\x73\x73\x61\x67\x65\x57\x68\x65\x6e\x57\x6f\x72\x6b\x69\x6e\x67"
,"\x74\x69\x6d\x65\x4f\x75\x74");__addState (
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x74\x65\x72\x6d\x69\x6e\x61\x74\x65");__addTransition (
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4e\x6f\x64\x65",
"\x74\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67");__addTransition (
"\x73\x74\x6f\x70\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x63\x6c\x65\x61\x6e\x41\x66\x74\x65\x72\x52\x65\x63\x6f\x72\x64",
"\x6e\x6f\x64\x65\x49\x73\x4e\x6f\x74\x52\x75\x6e\x6e\x69\x6e\x67");__addState (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4e\x6f\x64\x65",
"\x5f\x5f\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x52\x65\x63\x6f\x72\x64\x4e\x6f\x64\x65"
);__setInSelect (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4e\x6f\x64\x65",
$terminateTimeout);__addTransition (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4e\x6f\x64\x65",
"\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64"
,"\x74\x69\x6d\x65\x4f\x75\x74");__addState (
"\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64"
,
"\x5f\x5f\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64"
);__addTransition (
"\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64"
,
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x6b\x69\x6c\x6c\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");__addState (
"\x73\x65\x6e\x64\x50\x69\x6e\x67\x4d\x65\x73\x73\x61\x67\x65\x57\x68\x65\x6e\x57\x6f\x72\x6b\x69\x6e\x67"
,"\x5f\x5f\x73\x65\x6e\x64\x50\x69\x6e\x67");__addTransition (
"\x73\x65\x6e\x64\x50\x69\x6e\x67\x4d\x65\x73\x73\x61\x67\x65\x57\x68\x65\x6e\x57\x6f\x72\x6b\x69\x6e\x67"
,
"\x61\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x49\x73\x57\x6f\x72\x6b\x69\x6e\x67"
,"\x70\x69\x6e\x67\x53\x65\x6e\x74");__addTransition (
"\x73\x65\x6e\x64\x50\x69\x6e\x67\x4d\x65\x73\x73\x61\x67\x65\x57\x68\x65\x6e\x57\x6f\x72\x6b\x69\x6e\x67"
,
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x6b\x69\x6c\x6c\x52\x65\x63\x6f\x72\x64\x69\x6e\x67");__addState (
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x5f\x5f\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x52\x65\x63\x6f\x72\x64");
__addTransition (
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x77\x61\x69\x74\x54\x6f\x4b\x69\x6c\x6c\x4e\x6f\x64\x65",
"\x6b\x69\x6c\x6c\x69\x6e\x67");__addTransition (
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
,"\x65\x6d\x65\x72\x67\x65\x6e\x63\x79\x43\x6c\x65\x61\x6e",
"\x6e\x6f\x64\x65\x49\x73\x4e\x6f\x74\x52\x75\x6e\x6e\x69\x6e\x67");__addState (
"\x77\x61\x69\x74\x54\x6f\x4b\x69\x6c\x6c\x4e\x6f\x64\x65",
"\x5f\x5f\x77\x61\x69\x74\x54\x6f\x4b\x69\x6c\x6c\x52\x65\x63\x6f\x72\x64\x4e\x6f\x64\x65"
);__setInSelect ("\x77\x61\x69\x74\x54\x6f\x4b\x69\x6c\x6c\x4e\x6f\x64\x65",
$killTimeout);__addTransition (
"\x77\x61\x69\x74\x54\x6f\x4b\x69\x6c\x6c\x4e\x6f\x64\x65",
"\x6b\x69\x6c\x6c\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64",
"\x74\x69\x6d\x65\x4f\x75\x74");__addState (
"\x6b\x69\x6c\x6c\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64",
"\x5f\x5f\x6b\x69\x6c\x6c\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64"
);__setInSelect (
"\x6b\x69\x6c\x6c\x54\x69\x6d\x65\x6f\x75\x74\x52\x65\x61\x63\x68\x65\x64",
"\x69\x6e\x66");__addState (
"\x63\x6c\x65\x61\x6e\x41\x66\x74\x65\x72\x52\x65\x63\x6f\x72\x64",
"\x5f\x5f\x63\x6c\x65\x61\x6e\x41\x66\x74\x65\x72\x52\x65\x63\x6f\x72\x64");
__addState ("\x65\x6d\x65\x72\x67\x65\x6e\x63\x79\x43\x6c\x65\x61\x6e",
"\x5f\x5f\x65\x6d\x65\x72\x67\x65\x6e\x63\x79\x43\x6c\x65\x61\x6e\x75\x70");(
$rootDirPath=Common::NXPaths::getNodeRootDirectoryPath ());($statesInitialized=
(0x0c85+ 1184-0x1124));}if ((__createDirectories ()==(-(0x0e22+ 1228-0x12ed)))){
return ((0x0e91+ 3372-0x1bbd));}return ((0x1166+ 625-0x13d6));}sub 
__createDirectories{my ($errorMsg);(my $path=((((
NXNodeConfiguration::getNXRecordingDirectory ().$GLOBAL::DIRECTORY_SLASH).
"\x74\x6d\x70").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x63\x6f\x72\x64"));if ((
Common::NXFile::directoryExists ($path)==(0x1d09+ 256-0x1e09))){if ((not (
Common::NXPaths::makePath ((\$errorMsg),$path)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((-(0x1733+ 799-0x1a51)));}}return (
Common::NXFile::setOwnerShipNXAndFullPermissions ($path,(\$errorMsg)));}sub 
__addState{(my $stateName=shift (@_));(my $functionToHandle=shift (@_));if ((
$stateName eq (""))){Logger::error (
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x10bc+ 744-0x13a4));}if (($functionToHandle eq (""))){
Logger::error (
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0782+ 962-0x0b44));}($states{$stateName}=$functionToHandle);}
sub __addTransition{(my $beginState=shift (@_));(my $nextState=shift (@_));(my $event
=shift (@_));(my $break=shift (@_));if (($beginState eq (""))){(my ($package,
$filename,$line,$sub)=caller ((0x1a6a+ 1463-0x2020)));Logger::error (((((((((
"\x41\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x3a\x20\x62\x65\x67\x69\x6e\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
main::nxexit ((0x20a8+ 795-0x23c3));}if (($nextState eq (""))){Logger::error (((
"\x41\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x6e\x65\x78\x74\x20\x73\x74\x61\x74\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x09ad+ 1980-0x1169));}if (($event eq (""))){Logger::error (((
"\x41\x64\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x73\x74\x61\x74\x65\x20"
.$beginState).
"\x3a\x20\x65\x76\x65\x6e\x74\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
));main::nxexit ((0x0f88+ 855-0x12df));}($transition{$beginState}{$event}=
$nextState);}sub __getCurrentState{(my $sessionId=shift (@_));return (
$currentState{$sessionId});}sub __isCurrentState{(my $sessionId=shift (@_));(my $stateToCheck
=shift (@_));if (($currentState{$sessionId}eq $stateToCheck)){return (
(0x08c8+ 5480-0x1e2f));}return ((0x036d+ 4217-0x13e6));}sub __setCurrentState{(my $sessionId
=shift (@_));(my $state=shift (@_));($currentState{$sessionId}=$state);}sub 
__handleCurrentState{(my $sessionId=shift (@_));(my $currentState=
__getCurrentState ($sessionId));(my $functionToHandle=$states{$currentState});if
 (($functionToHandle eq (""))){Logger::warning (((
"\x49\x6e\x20\x73\x74\x61\x74\x65\x20".$currentState).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x68\x61\x6e\x64\x6c\x65\x2e"
));__emergencyCleanup ($sessionId);return;}Logger::debug (((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x74\x61\x74\x65\x3a\x20"
.$currentState)."\x2e"));return (\(&$functionToHandle ($sessionId)));}sub 
__setNextState{(my $sessionId=shift (@_));(my $event=shift (@_));if (($event eq 
(""))){Logger::warning (((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x20\x69\x6e\x20\x73\x74\x61\x74\x65\x20"
.__getCurrentState ($sessionId)).
"\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x64\x65\x63\x69\x64\x65\x20\x61\x62\x6f\x75\x74\x20\x6e\x65\x77\x20\x73\x74\x61\x74\x65\x20\x77\x69\x74\x68\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x2e"
));__emergencyCleanup ($sessionId);return;}(my $nextState=__getTransition (
$sessionId,$event));if ((not (defined ($nextState)))){__emergencyCleanup (
$sessionId);return;}__setCurrentState ($sessionId,$nextState);if (__isInSelect (
$sessionId)){($startWaitInSelect{$sessionId}=
Common::NXTime::getSecondsSinceEpoch ());}}sub __getTransition{(my $sessionId=
shift (@_));(my $event=shift (@_));(my $currentState=__getCurrentState (
$sessionId));if (($currentState eq (""))){(my ($package,$filename,$line,$sub)=
caller ((0x1896+ 2453-0x222a)));Logger::warning (((((((((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20\x65\x6d\x70\x74\x79\x20\x73\x74\x61\x74\x65\x2e\x20\x28"
.$package)."\x2c\x20").$filename)."\x2c\x20").$line)."\x2c\x20").$sub)."\x29"));
return (undef);}if (($event eq (""))){Logger::warning (((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x6f\x72\x20\x65\x6d\x70\x74\x79\x20\x65\x76\x65\x6e\x74\x20\x28"
.$currentState)."\x29\x2e"));return (undef);}(my $nextState=$transition{
$currentState}{$event});if (($nextState eq (""))){Logger::warning (((((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x74\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20"
.$event)."\x20\x28").$currentState)."\x29\x2e"));($nextState=
"\x6b\x69\x6c\x6c\x4e\x6f\x64\x65\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67"
);}Logger::debug (((((((
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x54\x72\x61\x6e\x73\x69\x74\x69\x6f\x6e\x20\x66\x72\x6f\x6d\x20"
.$currentState)."\x20\x77\x69\x74\x68\x20\x65\x76\x65\x6e\x74\x20").$event).
"\x20\x69\x73\x20").$nextState)."\x2e"));return ($nextState);}sub __setInSelect{
(my $stateName=shift (@_));(my $time=shift (@_));if (($stateName eq (""))){
Logger::error (
"\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x52\x65\x63\x6f\x72\x64\x20\x73\x74\x61\x74\x65\x20\x6d\x61\x63\x68\x69\x6e\x65\x3a\x20\x73\x74\x61\x74\x65\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x13f0+ 3050-0x1fda));}($waitInSelect{$stateName}=$time);}sub 
__changeTerminateTimeout{(my $timeout=shift (@_));($waitInSelect{
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4e\x6f\x64\x65"}=
$timeout);($terminateTimeout=$timeout);}sub __isInSelect{(my $sessionId=shift (
@_));(my $currentState=__getCurrentState ($sessionId));if (defined (
$waitInSelect{$currentState})){return ((0x06f0+ 1042-0x0b01));}}sub __isReady{(my $sessionId
=shift (@_));if ((not (defined ($currentState{$sessionId})))){return (
(0x0171+ 2172-0x09ed));}if (__isInSelect ($sessionId)){(my $timeOut=getTimeout (
$sessionId));if (($timeOut eq "\x69\x6e\x66")){return ((0x0e1b+ 324-0x0f5f));}if
 (((($startWaitInSelect{$sessionId}+$timeOut)-
Common::NXTime::getSecondsSinceEpoch ())<=(0x033b+ 6524-0x1cb7))){__setNextState
 ($sessionId,"\x74\x69\x6d\x65\x4f\x75\x74");return ((0x1c48+ 2636-0x2693));}
return ((0x0eea+ 3338-0x1bf4));}return ((0x0651+ 5207-0x1aa7));}sub 
__initAutomaticRecording{();}sub __automaticRecordingStarted{();}sub 
__waitToStartOrStopMessage{();}sub __waitToStartNodeRecord{();}sub 
__waitToTerminateRecordNode{();}sub __waitToUnpauseAutomaticRecording{();}sub 
__waitToKillRecordNode{();}sub __setScreenBlanking{(my $sessionId=shift (@_));if
 ((NXLocalSession::getActiveLocalSessionId ()eq 
NXSession2::getMainSessionIdBySessionId ($sessionId))){
NXLocalSession::increaseRecordingCounter ();}}sub __resetScreenBlanking{(my $sessionId
=shift (@_));if ((NXLocalSession::getActiveLocalSessionId ()eq 
NXSession2::getMainSessionIdBySessionId ($sessionId))){
NXLocalSession::decreaseRecordingCounter ();}}sub emergencyCleanAutomaticRecord{
(my $sessionId=shift (@_));(my $oldName=__getTmpRecordingPath ($sessionId));(my (
$newName,$username)=__getFinishedRecordingPath ($sessionId));Logger::debug (((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x3a\x20\x4d\x6f\x76\x65\x3a\x20\x27"
.$oldName)."\x27\x20\x74\x6f\x20\x27").$newName)."\x27\x2e"));if ((
libnxh::NXFileRename ($oldName,$newName)!=(0x02bb+ 4154-0x12f5))){
Logger::warning ((((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20\x27"
.$oldName)."\x27\x20\x74\x6f\x20\x27").$newName)."\x27\x3a\x20").
libnxh::NXGetErrorString ()));if ((libnxh::NXFileRemove ($oldName)!=
(0x012c+ 340-0x0280))){Logger::warning ((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20\x27"
.$oldName)."\x27\x2e\x20").libnxh::NXGetErrorString ()));}}my ($errorName,
$errorCode);if ((Common::NXFile::setPermissionsReadWriteForUserAndAdmin (
$newName,$username,(\$errorName),(\$errorCode))==(-(0x0d7f+ 555-0x0fa9)))){
Logger::warning (((((((
"\x4e\x58\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x52\x65\x63\x6f\x72\x64\x69\x6e\x67\x4e\x6f\x64\x65\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20"
.$username).
"\x20\x72\x65\x63\x6f\x72\x64\x69\x6e\x67\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
).$errorCode)."\x3a\x20").$errorName)."\x2e"));}}sub __runReniceScript{(my $pid=
shift (@_));(my (@command)=($GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXRENICE,$pid
));(my (@options)="\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");main::nxRunCommand ((
\@command),(\@options));}return ((0x026a+ 3710-0x10e7));
