############################################################################
#                                                                          #
#  Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXClusterTools::generateClusterGUID{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);push (@command,
"\x2d\x75");(my (@options)=());push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmdErr,$cmdOut,
$exitValue)=main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x0d68+ 5024-0x2108))){Logger::warning (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x6e\x65\x72\x61\x74\x65\x20\x47\x55\x49\x44\x2e"
);return ((""));}chomp ($cmdOut);return ($cmdOut);}sub 
NXClusterTools::generateClusterKeys{package NXClusterTools;no warnings;(my (
@command)=());push (@command,$GLOBAL::COMMAND_NXKEYGEN);(my $priv=
NXPaths::getClusterRSAPrivateKey ());(my $pub=NXPaths::getClusterRSAPublicKey ()
);push (@command,"\x2d\x6b",$priv);push (@command,"\x2d\x70",$pub);push (
@command,"\x2d\x74","\x72\x73\x61");(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));push (@options,"\x73\x65\x74\x20\x65\x6e\x76",(
"\x48\x4f\x4d\x45\x3d".NXPaths::getUserNXHomeDir ()));(my ($cmd_err,$cmd_out,
$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x01e9+ 3413-0x0f3d))))
{Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20\x27"
.$priv)."\x27\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x1891+ 787-0x1ba3)))){Logger::warning (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::generateClusterHostCerts{package 
NXClusterTools;no warnings;(my (@command)=());push (@command,
$GLOBAL::COMMAND_NXKEYGEN);(my $priv=NXPaths::getClusterHostPrivateCert ());(my $pub
=NXPaths::getClusterHostPublicCert ());push (@command,"\x2d\x6b",$priv);push (
@command,"\x2d\x63",$pub);(my (@options)=());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(((
"\x4c\x44\x5f\x4c\x49\x42\x52\x41\x52\x59\x5f\x50\x41\x54\x48\x3d".
$GLOBAL::NODE_ROOT).$GLOBAL::DIRECTORY_SLASH)."\x6c\x69\x62"));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x53\x59\x53\x54\x45\x4d\x3d".
$GLOBAL::NODE_ROOT));(my $homeDir=NXPaths::getUserNXHomeDir ());push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x48\x4f\x4d\x45\x3d".$homeDir));(my ($cmd_err,
$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@options)));
changeFileOwnershipToNxIfRoot ($priv);changeFileOwnershipToNxIfRoot ($pub);if ((
Common::NXFile::setPermissionsReadWriteForNX ($priv)==(-(0x0387+ 3397-0x10cb))))
{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$priv)."\x2e"));}if ((
Common::NXFile::setPermissionReadWriteForOwnerReadOnlyForAll ($pub)==(-
(0x00ec+ 1120-0x054b)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x74\x6f\x20"
.$pub)."\x2e"));}}sub NXClusterTools::cleanInterface{package NXClusterTools;no 
warnings;(my $interface=$GLOBAL::ClusterInterface);(my $clusterHost=
$GLOBAL::ClusterHost);(my $mask=$GLOBAL::ClusterNetmask);if ((
$GLOBAL::ScriptClusterClearSharedIP ne (""))){main::nxrequire (
"\x4e\x58\x53\x63\x72\x69\x70\x74\x73");return (NXScripts::runScript (
"\x73\x63\x72\x69\x70\x74\x5f\x63\x6c\x75\x73\x74\x65\x72\x5f\x63\x6c\x65\x61\x72\x5f\x73\x68\x61\x72\x65\x64\x5f\x69\x70"
,$interface,$clusterHost,$mask));}(my (%interfaces)=getInterfaces ());if ((
$interfaces{$interface}eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"))
;(($interface,$clusterHost)=__readInterfaceFromFile ());if (($interfaces{
$interface}eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface).
"\x27\x20\x66\x72\x6f\x6d\x20\x66\x69\x6c\x65\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x6c\x65\x61\x6e\x20\x75\x70\x2e"
));return ((0x08bd+ 7372-0x2589));}}Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x3a\x20\x43\x6c\x65\x61\x6e\x20\x75\x70\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x20\x68\x6f\x73\x74\x20\x27").$clusterHost)."\x27\x2e"));(my (
@command)=());sub BEGIN{require NXTools;do{"\x4e\x58\x54\x6f\x6f\x6c\x73"->
import};}if ((not (($interface=~ /(.*):(\d+)/ )))){if ((not (
NXMsg::isMessageRegistered (
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
)))){NXMsg::register_error (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73",
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
,$GLOBAL::MSG_ERROR);}Common::NXMsg::error (
"\x65\x43\x4d\x44\x43\x6c\x75\x73\x74\x65\x72\x49\x6e\x76\x61\x6c\x69\x64\x49\x6e\x74\x65\x72\x66\x61\x63\x65"
,$interface);return ((0x0c52+ 5470-0x21af));}(my $device=$1);if ((
$GLOBAL::ForceClusterIfconfig eq "\x31")){push (@command,
NXTools::getUnixCommandPath ("\x69\x66\x63\x6f\x6e\x66\x69\x67"));push (@command
,$interface);push (@command,"\x64\x6f\x77\x6e");}else{push (@command,
NXTools::getUnixCommandPath ("\x69\x70"));push (@command,
"\x61\x64\x64\x72\x65\x73\x73","\x64\x65\x6c\x65\x74\x65");push (@command,((
$clusterHost."\x2f").$mask));push (@command,"\x64\x65\x76",$device);push (
@command,"\x6c\x61\x62\x65\x6c",$interface);}(my (@options)=());(my ($cmdOut,
$cmdErr,$exitValue)=main::nxRunCommand ((\@command),(\@options)));Logger::debug 
((((((("\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x6f\x75\x74\x70\x75\x74\x20\x27".
$cmdOut)."\x27\x20\x27").$cmdErr).
"\x27\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x27").$exitValue)."\x27\x2e"))
;if (($exitValue!=(0x104c+ 2076-0x1868))){Logger::error (((((((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x64\x65\x6c\x65\x74\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$interface)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$exitValue)
."\x27\x2e\x20\x27").$cmdOut)."\x27\x20\x27").$cmdErr)."\x27\x2e"));}
removeInterfaceFile ();return ($exitValue);}sub 
NXClusterTools::saveInterfaceToFile{package NXClusterTools;no warnings;(my $interface
=shift (@_));(my $clusterHost=shift (@_));(my $filename=
NXPaths::getClusterInterfaceFile ());(my $fileExisted=(0x1458+ 1731-0x1b1b));if 
(Common::NXFile::fileExists ($filename)){($fileExisted=(0x02e8+ 2532-0x0ccb));}(my $FH
=main::nxopen ($filename,($NXBits::O_RDWR+$NXBits::O_CREAT),((
$NXBits::OthersRead+$NXBits::UserReadWrite)+$NXBits::GroupRead)));if ((not (
defined ($FH)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20".$filename
)."\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorstring).
"\x2e"));return ((0x23fc+ 692-0x26af));}if ((main::nxwrite ($FH,((($interface.
"\x0a").$clusterHost)."\x0a"))==(-(0x0b79+ 1828-0x129c)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$filename)."\x27\x2e"));main::nxclose ($FH);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($filename);}return ((0x01bb+ 563-0x03ed));}
main::nxclose ($FH);if ((not ($fileExisted))){changeFileOwnershipToNxIfRoot (
$filename);}return ((0x16ec+ 2728-0x2194));}sub 
NXClusterTools::removeInterfaceFile{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::isExists ($filename)){
Common::NXFile::removeFile ($filename);}}sub 
NXClusterTools::doesInterfaceFileExist{package NXClusterTools;no warnings;(my $filename
=NXPaths::getClusterInterfaceFile ());if (Common::NXFile::fileExists ($filename)
){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x69\x6c\x65\x20\x27"
.$filename)."\x27\x20\x65\x78\x69\x73\x74\x73\x2e"));return (
(0x03db+  74-0x0424));}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x69\x6c\x65\x20\x27"
.$filename).
"\x27\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return 
((0x0918+ 7587-0x26bb));}sub NXClusterTools::__readInterfaceFromFile{package 
NXClusterTools;no warnings;if ((not (doesInterfaceFileExist ()))){return ((""),
(""));}(my $filename=NXPaths::getClusterInterfaceFile ());(my $FH=main::nxopen (
$filename,$NXBits::O_RDONLY,(0x03b5+ 3409-0x1106)));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27".
$filename)."\x27\x20\x66\x6f\x72\x20\x72\x65\x61\x64\x69\x6e\x67\x2e"));
Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber).
"\x2c\x20").$errorstring)."\x2e"));return ((""),(""));}my ($interface);my (
$clusterHost);main::nxreadLine ($FH,(\$interface));main::nxreadLine ($FH,(
\$clusterHost));main::nxclose ($FH);chomp ($interface);chomp ($clusterHost);
return ($interface,$clusterHost);}sub NXClusterTools::getInterfaces{package 
NXClusterTools;no warnings;(my (%interfaces)=());Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (@lines)=split ( /\n/ ,$return,(0x0ff7+ 1617-0x1648))
);foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){Logger::debug ((((((("\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27".$1).
"\x27\x2c\x20\x49\x50\x20\x27").$4)."\x27\x20\x6d\x61\x73\x6b\x20\x27").$5).
"\x27\x2e"));($interfaces{$1}={"\x69\x70",$4,"\x6d\x61\x73\x6b",$5});}}return (
%interfaces);}sub NXClusterTools::getIPs{package NXClusterTools;no warnings;
Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73"
);(my $return=libnxh::NXGetNetworkInterfaces ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x47\x65\x74\x4e\x65\x74\x77\x6f\x72\x6b\x49\x6e\x74\x65\x72\x66\x61\x63\x65\x73\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$return)."\x27\x2e"));(my (%IPs)=());(my (@lines)=split ( /\n/ ,$return,
(0x0d7f+ 2008-0x1557)));foreach my $line (@lines){if (($line=~ /(^[\w:\d]+)\s+AF_INET\s+([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})+\s+(\d+\.\d+\.\d+\.\d+)\s+(\d+\.\d+\.\d+\.\d+)/ )
){(my $iface=$1);(my $ip=$4);(my $mask=$5);Logger::debug (((((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27"
.$iface)."\x27\x20\x49\x50\x20\x27").$ip)."\x27\x20\x6d\x61\x73\x6b\x20\x27").
$mask)."\x27\x2e"));($IPs{$ip}={"\x69\x6e\x74\x65\x72\x66\x61\x63\x65",$iface,
"\x6d\x61\x73\x6b",$mask});}}return (%IPs);}sub NXClusterTools::isIPExists{
package NXClusterTools;no warnings;(my $IP=shift (@_));Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x61\x72\x63\x68\x20\x49\x50\x20\x27"
.$IP).
"\x27\x20\x6f\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x6c\x69\x73\x74\x2e"
));(my (%interfaces)=getInterfaces ());foreach my $name (keys (%interfaces)){if 
(($interfaces{$name}{"\x69\x70"}eq $ip)){Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x46\x6f\x75\x6e\x64\x20\x49\x50\x20\x27"
.$IP)."\x27\x20\x6f\x6e\x20\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x20\x27").$name)
."\x27\x2e"));return ((0x0bb6+ 2753-0x1676));}}Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x49\x50\x20\x27"
.$IP)."\x27\x2e"));return ((0x01b6+ 3750-0x105c));}sub 
NXClusterTools::getClusterPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterRSAPublicKey ());if ((not (Common::NXFile::fileExists ($file
)))){generateClusterKeys ();}(my $content=Common::NXFile::getFileContent ($file)
);if (($content eq (""))){(my $message=((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x70\x75\x6c\x69\x63\x20\x6b\x65\x79\x20\x66\x72\x6f\x6d\x20\x70\x61\x74\x68\x20\x27"
.$file)."\x27"));Logger::error ($message);die ($message);}return ($content);}sub
 NXClusterTools::__setDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));(my $content=shift (@_));if (__isDatabaseBackupExist ($database)){
Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$database).
"\x27\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x65\x78\x69\x73\x74\x73\x2e"));return 
((0x1f4b+ 1907-0x26be));}if (($content eq (""))){Logger::debug (((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$database)."\x27\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"));return (
(0x0158+ 9480-0x2660));}($content=main::urlencode ($content));NXRedis::sendToDb 
(((((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x65\x74\x6e\x78\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x2c\x76\x61\x6c\x75\x65\x3d").$content)."\x0a"));}sub 
NXClusterTools::getNodesDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");return (NXNodes::getDatabaseInString ());}sub 
NXClusterTools::getClusterDB{package NXClusterTools;no warnings;return (
getDatabaseInString ());}sub NXClusterTools::getProfilesDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");return (
NXProfilesDB::getDatabaseInString ());}sub NXClusterTools::getUsersDB{package 
NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");return (
NXUsersManager::getDatabaseInString ());}sub NXClusterTools::getAdministratorsDB
{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);return (NXAdministratorsManager::getDatabaseInString ());}sub 
NXClusterTools::getGroupsDB{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");return (NXGroups::getDatabaseInString ());}
sub NXClusterTools::getNodeGroupsDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73",
"\x69\x6e\x69\x74");return (NXNodeGroups::getDatabaseInString ());}sub 
NXClusterTools::getServerGroupsDB{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73",
"\x69\x6e\x69\x74");return (NXServerGroups::getDatabaseInString ());}sub 
NXClusterTools::getNXCerts{package NXClusterTools;no warnings;main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (NXServers::getNXCertsString ());
}sub NXClusterTools::getSSHCerts{package NXClusterTools;no warnings;
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");return (
NXServers::getSSHCertsString ());}sub NXClusterTools::getNetworkDB{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getNetworkDB ()));}sub NXClusterTools::getNetworkFile{package 
NXClusterTools;no warnings;return (Common::NXFile::getFileContent (
NXPaths::getNetworkFile ()));}sub NXClusterTools::getServerDSAPublicKey{package 
NXClusterTools;no warnings;(my $file=NXPaths::getServerDSAPublicKey ());if ((not
 (Common::NXFile::fileExists ($file)))){return ((""));}return (
Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerDSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerDSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPublicKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPublicKey ());if ((not (Common::NXFile::fileExists ($file)
))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getServerRSAPrivateKey{package NXClusterTools;no warnings;(my $file
=NXPaths::getServerRSAPrivateKey ());if ((not (Common::NXFile::fileExists ($file
)))){return ((""));}return (Common::NXFile::getFileContent ($file));}sub 
NXClusterTools::getPlayerCerts{package NXClusterTools;no warnings;(my $file=
NXPaths::getUserNXKnownCerts ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::getClusterMasterCertPub{package 
NXClusterTools;no warnings;(my $file=NXPaths::getClusterHostPublicCert ());if ((
not (Common::NXFile::fileExists ($file)))){generateClusterHostCerts ();}(my $content
=Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterMasterCertPriv{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHostPrivateCert ());if ((not (Common::NXFile::fileExists (
$file)))){generateClusterHostCerts ();}(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPrivateCert{package NXClusterTools;no warnings;(my $file
=NXPaths::getHttpHostPrivateCert ());(my $content=Common::NXFile::getFileContent
 ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getHttpHostPublicCert{package NXClusterTools;no warnings;(my $file
=NXPaths::getHttpHostPublicCert ());(my $content=Common::NXFile::getFileContent 
($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getClusterHttpMasterCertPub{package NXClusterTools;no warnings;(my $file
=NXPaths::getClusterHttpHostPublicCert ());(my $content=
Common::NXFile::getFileContent ($file));if (($content eq (""))){(my $message=(
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x66\x69\x6c\x65\x3a\x20"
.$file));Logger::error ($message);die ($message);}return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPrivate ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyDSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyRSAPrivate{package
 NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyRSAPrivate ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyRSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyRSAPublic ());(my $content=Common::NXFile::getFileContent
 ($file));return ($content);}sub NXClusterTools::getSSHHostKeyECDSAPrivate{
package NXClusterTools;no warnings;(my $file=NXPaths::getSSHHostKeyECDSAPrivate 
());(my $content=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyECDSAPublic ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyED25519Private{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyED25519Private ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getSSHHostKeyED25519Public{package NXClusterTools;no warnings;(my $file
=NXPaths::getSSHHostKeyED25519Public ());(my $content=
Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::getUserKnownHostsSSH{package NXClusterTools;no warnings;return (
Common::NXFile::getFileContent (NXPaths::getUserKnownHostsSSH ()));}sub 
NXClusterTools::__unsync{package NXClusterTools;no warnings;(my $file=shift (@_)
);(my $owner=shift (@_));(my $emptyFile=($file."\x2e\x65\x6d\x70\x74\x79"));if (
Common::NXFile::fileExists ($emptyFile)){__remove ($emptyFile);__remove ($file);
return ((0x065f+ 2112-0x0e9f));}(my $fileBackup=($file.
"\x2e\x62\x61\x63\x6b\x75\x70"));if (Common::NXFile::fileExists ($fileBackup)){
Logger::debug ((((("\x52\x65\x6e\x61\x6d\x65\x20\x27".$fileBackup).
"\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e"));unless (rename ($fileBackup,
$file)){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file)."\x27\x2e\x20").$!));return (
(0x1c44+ 2289-0x2534));}if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x1571+ 1415-0x1af8));}sub 
NXClusterTools::__unsyncDatabases{package NXClusterTools;no warnings;
Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x64\x65\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65\x20\x64\x61\x74\x61\x62\x61\x73\x65\x73\x2e"
);if (__isDatabaseBackupExist ("\x6e\x6f\x64\x65\x73")){main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");NXNodes::cleanDb ();NXNodes::setDatabaseByString
 (__getDatabaseBackup ("\x6e\x6f\x64\x65\x73"));}if (__isDatabaseBackupExist (
"\x70\x72\x6f\x66\x69\x6c\x65\x73")){main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");NXProfilesDB::cleanDb ();
NXProfilesDB::setDatabaseByString (__getDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73"));}main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73");NXNodeGroups::cleanDb ();
NXRemoteMachinesGroups::cleanLoadedGroups ();if (__isDatabaseBackupExist (
"\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73")){NXNodeGroups::setDatabaseByString (
__getDatabaseBackup ("\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73"));}
main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73");
NXServerGroups::cleanDb ();NXRemoteMachinesGroups::cleanLoadedGroups ();if (
__isDatabaseBackupExist ("\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73")){
NXServerGroups::setDatabaseByString (__getDatabaseBackup (
"\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73"));}if (
__isDatabaseBackupExist ("\x75\x73\x65\x72\x73")){main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");
NXUsersManager::cleanDb ();NXUsersManager::setDatabaseByString (
__getDatabaseBackup ("\x75\x73\x65\x72\x73"));}if (__isDatabaseBackupExist (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73")){main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);NXAdministratorsManager::cleanDb ();
NXAdministratorsManager::setDatabaseByString (__getDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x4e\x58")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setNXCertsByString (undef,
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58"));}if (
__isDatabaseBackupExist ("\x63\x65\x72\x74\x73\x53\x53\x48")){main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x73");NXServers::setSSHCertsByString (undef,
__getDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48"));}if (
__isDatabaseBackupExist ("\x67\x72\x6f\x75\x70\x73")){main::nxrequire (
"\x4e\x58\x47\x72\x6f\x75\x70\x73");NXGroups::cleanDb ();
NXGroups::setDatabaseByString (__getDatabaseBackup ("\x67\x72\x6f\x75\x70\x73"))
;}}sub NXClusterTools::__isDatabaseBackupExist{package NXClusterTools;no 
warnings;(my $database=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x69\x73\x74\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (NXRedis::get ());}sub 
NXClusterTools::__getDatabaseBackup{package NXClusterTools;no warnings;(my $database
=shift (@_));NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x62\x61\x63\x6b\x75\x70\x2e"
.$database)."\x0a"));return (main::urldecode (NXRedis::get ()));}sub 
NXClusterTools::__remove{package NXClusterTools;no warnings;(my $file=shift (@_)
);if (Common::NXFile::fileExists ($file)){Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x5b".$file)."\x5d"));if ((not (unlink (
$file)))){Logger::error ((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x66\x69\x6c\x65\x20".
$file)."\x20").$!));}}}sub NXClusterTools::unsynchronize{package NXClusterTools;
no warnings;(my $host=shift (@_));__unsync (NXPaths::getUserNXKnownCerts ());
__unsync (NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));__unsync (
NXPaths::getNodePublicKeys ());if ((
Common::NXFile::setOwnerShipAndPermissionsReadOnlyForNX (
NXPaths::getNodePublicKeys ())==(-(0x109a+ 4617-0x22a2)))){Logger::error ((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x66\x69\x6c\x65\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x3a\x20"
.NXPaths::getNodePublicKeys ()));}__unsync (NXPaths::getUserKnownHostsSSH ());
__unsyncDatabases ();__remove (NXPaths::getClusterHostPublicCert ());__remove (
NXPaths::getClusterHostPrivateCert ());if (($host ne "\x6c\x6f\x63\x61\x6c")){
cleanDb ();}__unsync (NXPaths::getNetworkFile ());__unsync (
NXPaths::getNetworkDB ());}sub NXClusterTools::cleanSSHKeys{package 
NXClusterTools;no warnings;__unsync (NXPaths::getSSHHostKeyDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyRSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyECDSAPrivate (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyECDSAPublic (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyED25519Private (),
"\x72\x6f\x6f\x74");__unsync (NXPaths::getSSHHostKeyED25519Public (),
"\x72\x6f\x6f\x74");}sub NXClusterTools::addClusterKey{package NXClusterTools;no
 warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights=
$NXBits::UserReadWrite);return (__appendFile ($file,$rights,$fileContent,
(0x0983+ 5894-0x1f09)));}sub NXClusterTools::setNodesDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x4e\x6f\x64\x65\x73");__setDatabaseBackup ("\x6e\x6f\x64\x65\x73",
NXNodes::getDatabaseInString ());NXNodes::cleanDb ();return (
NXNodes::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setNodeGroupsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire ("\x4e\x58\x4e\x6f\x64\x65\x47\x72\x6f\x75\x70\x73"
,"\x69\x6e\x69\x74");__setDatabaseBackup (
"\x6e\x6f\x64\x65\x67\x72\x6f\x75\x70\x73",NXNodeGroups::getDatabaseInString ())
;NXNodeGroups::cleanDb ();return (NXNodeGroups::setDatabaseByString (
$fileContent));}sub NXClusterTools::setServerGroupsDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x53\x65\x72\x76\x65\x72\x47\x72\x6f\x75\x70\x73","\x69\x6e\x69\x74");
__setDatabaseBackup ("\x73\x65\x72\x76\x65\x72\x67\x72\x6f\x75\x70\x73",
NXServerGroups::getDatabaseInString ());NXServerGroups::cleanDb ();
NXServerGroups::cleanLoadedGroups ();return (NXServerGroups::setDatabaseByString
 ($fileContent));}sub NXClusterTools::setClusterDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));cleanDb ();return (setDatabaseByString (
$fileContent));}sub NXClusterTools::setProfilesDB{package NXClusterTools;no 
warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x50\x72\x6f\x66\x69\x6c\x65\x73\x44\x42");__setDatabaseBackup (
"\x70\x72\x6f\x66\x69\x6c\x65\x73",NXProfilesDB::getDatabaseInString ());
NXProfilesDB::cleanDb ();return (NXProfilesDB::setDatabaseByString ($fileContent
));}sub NXClusterTools::setUsersDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));main::nxrequire (
"\x4e\x58\x55\x73\x65\x72\x73\x4d\x61\x6e\x61\x67\x65\x72");__setDatabaseBackup 
("\x75\x73\x65\x72\x73",NXUsersManager::getDatabaseInString ());
NXUsersManager::cleanDb ();return (NXUsersManager::setDatabaseByString (
$fileContent));}sub NXClusterTools::setAdministratorsDB{package NXClusterTools;
no warnings;(my $fileContent=shift (@_));main::nxrequire (
"\x4e\x58\x41\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73\x4d\x61\x6e\x61\x67\x65\x72"
);__setDatabaseBackup (
"\x61\x64\x6d\x69\x6e\x69\x73\x74\x72\x61\x74\x6f\x72\x73",
NXAdministratorsManager::getDatabaseInString ());
NXAdministratorsManager::cleanDb ();return (
NXAdministratorsManager::setDatabaseByString ($fileContent));}sub 
NXClusterTools::setGroupsDB{package NXClusterTools;no warnings;(my $fileContent=
shift (@_));main::nxrequire ("\x4e\x58\x47\x72\x6f\x75\x70\x73");
__setDatabaseBackup ("\x67\x72\x6f\x75\x70\x73",NXGroups::getDatabaseInString ()
);NXGroups::cleanDb ();return (NXGroups::setDatabaseByString ($fileContent));}
sub NXClusterTools::setNXCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x4e\x58\x20\x63\x65\x72\x74\x73\x2e"
);main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $ref_certs=
NXServers::getNXCertsHash ());(my $backup=NXShell::hashParameters2Url (
%$ref_certs));__setDatabaseBackup ("\x63\x65\x72\x74\x73\x4e\x58",$backup);
return (NXServers::setNXCertsByString ($ref_certs,$fileContent));}sub 
NXClusterTools::setSSHCertsDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x53\x53\x48\x20\x63\x65\x72\x74\x73\x2e"
);main::nxrequire ("\x4e\x58\x53\x65\x72\x76\x65\x72\x73");(my $ref_certs=
NXServers::getSSHCertsHash ());(my $backup=NXShell::hashParameters2Url (
%$ref_certs));__setDatabaseBackup ("\x63\x65\x72\x74\x73\x53\x53\x48",$backup);
return (NXServers::setSSHCertsByString ($ref_certs,$fileContent));}sub 
NXClusterTools::setNetworkDB{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNetworkDB ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x03e4+ 855-0x05bb)));}sub NXClusterTools::setNetworkFile{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNetworkFile ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x089f+ 2286-0x0fe9)));}sub NXClusterTools::setServerDSAPublicKey{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPublicKey ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));return (__setFile ($file,$rights,
$fileContent,(0x0d71+ 5298-0x207f)));}sub NXClusterTools::setServerDSAPrivateKey
{package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getServerDSAPrivateKey ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x1965+ 2434-0x2167)));}sub 
NXClusterTools::setServerRSAPublicKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPublicKey ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));return (
__setFile ($file,$rights,$fileContent,(0x176f+ 2271-0x1eaa)));}sub 
NXClusterTools::setServerRSAPrivateKey{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getServerRSAPrivateKey ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x09cb+ 6086-0x2011)));}sub NXClusterTools::setClientCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserNXKnownCerts ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0388+ 9230-0x2616)));}sub 
NXClusterTools::setAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNXAuthorizedKeysPath ("\x6e\x78"));(my $rights
=$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x1986+ 1479-0x1dcd)));}sub NXClusterTools::addSSHAuthorizedCerts{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getNodePublicKeys ());if (Common::NXFile::fileExists ($file)){my (
$error);if ((Common::NXFile::setPermissionsReadWriteForNX ($file,(\$error))==(-
(0x0778+ 3711-0x15f6)))){Logger::error (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20\x27"
.$file)."\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error).
"\x27\x2e"));return ((0x02f6+ 6602-0x1cbf));}}(my $rights=$NXBits::UserReadWrite
);return (__appendFile ($file,$rights,$fileContent,(0x0a18+ 2651-0x12f3)));}sub 
NXClusterTools::setSSHAuthorizedCerts{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getNodePublicKeys ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x05f4+ 8778-0x26be)));}sub NXClusterTools::__setHostPrivateCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPrivateCert ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x0ca2+ 6736-0x2572)));}sub 
NXClusterTools::__setHostPublicCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPublicCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x14f1+ 4499-0x2504)));}sub NXClusterTools::setClusterMasterCertPub{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getClusterHostPublicCert ());(my $rights=$NXBits::UserReadWrite);return
 (__setFile ($file,$rights,$fileContent,(0x0e63+ 1454-0x1291)));}sub 
NXClusterTools::setClusterMasterCertPriv{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getClusterHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);return (__setFile ($file,$rights,$fileContent,
(0x0545+ 3079-0x0fcc)));}sub NXClusterTools::setKnownHostsSSH{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getUserKnownHostsSSH ());(my $rights=$NXBits::UserReadWrite);return (
__setFile ($file,$rights,$fileContent,(0x01b9+ 235-0x0124)));}sub 
NXClusterTools::setSSHHostKeyDSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyDSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x09d1+ 3268-0x1515),"\x72\x6f\x6f\x74");return ((0x12ff+ 3278-0x1fcd));}sub 
NXClusterTools::setSSHHostKeyDSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyDSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x1786+ 2195-0x1e75),"\x72\x6f\x6f\x74");return (
(0x0aff+ 6883-0x25e2));}sub NXClusterTools::setSSHHostKeyRSAPrivate{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyRSAPrivate ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x0224+ 5477-0x1609),"\x72\x6f\x6f\x74");
return ((0x0c97+ 1205-0x114c));}sub NXClusterTools::setSSHHostKeyRSAPublic{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyRSAPublic ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x1cf5+ 2715-0x25ec),"\x72\x6f\x6f\x74");return ((0x1746+ 2381-0x2093));}sub 
NXClusterTools::setSSHHostKeyECDSAPrivate{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyECDSAPrivate ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x0f3d+ 6051-0x2560),"\x72\x6f\x6f\x74");return ((0x1577+ 1799-0x1c7e));}sub 
NXClusterTools::setSSHHostKeyECDSAPublic{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getSSHHostKeyECDSAPublic ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));__setFile (
$file,$rights,$fileContent,(0x0425+ 7961-0x219a),"\x72\x6f\x6f\x74");return (
(0x0cf3+ 6153-0x24fc));}sub NXClusterTools::setSSHHostKeyED25519Private{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyED25519Private ());(my $rights=$NXBits::UserReadWrite);
__setFile ($file,$rights,$fileContent,(0x1320+ 2346-0x1aca),"\x72\x6f\x6f\x74");
return ((0x1c20+ 904-0x1fa8));}sub NXClusterTools::setSSHHostKeyED25519Public{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getSSHHostKeyED25519Public ());(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x05f4+ 5945-0x1b89),"\x72\x6f\x6f\x74");return ((0x0392+ 7732-0x21c6));}sub 
NXClusterTools::__backupPrevious{package NXClusterTools;no warnings;(my $path=
shift (@_));(my $rights=shift (@_));(my $owner=shift (@_));(my $body=shift (@_))
;if ((not (Common::NXFile::fileExists ($path)))){(my $emptyFile=($path.
"\x2e\x65\x6d\x70\x74\x79"));(my $FH=main::nxopen ($emptyFile,($NXBits::O_RDWR+
$NXBits::O_CREAT),(($NXBits::OthersRead+$NXBits::UserReadWrite)+
$NXBits::GroupRead)));if ((not (defined ($FH)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$emptyFile)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorString).
"\x2e"));return ((0x0701+ 3518-0x14be));}main::nxclose ($FH);if (($owner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($emptyFile);}return (
(0x0864+ 6018-0x1fe6));}(my $backup=($path."\x2e\x62\x61\x63\x6b\x75\x70"));if (
Common::NXFile::fileExists ($backup)){($backup.=("\x2d".NXTools::getTimeMs ()));
}if (($body ne (""))){(my $FH=main::nxopen ($backup,($NXBits::O_RDWR+
$NXBits::O_CREAT),$NXBits::UserReadWrite));if ((not (defined ($FH)))){(my $errorNumber
=libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x27"
.$emptyFile)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x2c\x20").$errorString).
"\x2e"));return ((0x16ad+ 2034-0x1e9e));}if ((main::nxwrite ($FH,$body)==(-
(0x0929+ 262-0x0a2e)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$backup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($FH);if (($backupOwner ne 
"\x72\x6f\x6f\x74")){changeFileOwnershipToNxIfRoot ($backup);}return (
(0x1eb9+ 1965-0x2665));}main::nxclose ($FH);if (($owner ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($backup);}return ((0x0337+ 7415-0x202e));}else{(my (
$retValue,$outMsg)=Common::NXCore::copyFile ($path,$backup));if (($outMsg ne 
(""))){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x70\x79\x20\x27".$path).
"\x27\x20\x74\x6f\x20\x27").$backup).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$outMsg)."\x27\x2e"));
return ((0x00a2+ 3340-0x0dad));}}my ($error);if ((Common::NXFile::setPermission 
($backup,$rights,(\$error))==(-(0x146f+ 3309-0x215b)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x72\x69\x67\x68\x74\x73\x20\x74\x6f\x20"
.$backup)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$error)."\x27\x2e"
));return ((0x09ca+ 1635-0x102c));}unless (Common::NXFile::fileExists ($backup))
{Logger::error (((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x63\x72\x65\x61\x74\x65\x20\x66\x69\x6c\x65\x20\x62\x61\x63\x6b\x75\x70\x20\x27"
.$backup)."\x27\x20\x66\x6f\x72\x20\x27").$path)."\x27\x2e"));return (
(0x0007+ 5598-0x15e4));}if ((($owner ne "\x72\x6f\x6f\x74")and ($owner ne 
"\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot ($backup);}return (
(0x0921+ 2613-0x1356));}sub NXClusterTools::__setFile{package NXClusterTools;no 
warnings;(my $file=shift (@_));(my $rights=shift (@_));(my $fileBody=shift (@_))
;(my $backupRights=shift (@_));(my $backupOwner=shift (@_));(my $backupBody=
shift (@_));if (__backupPrevious ($file,$backupRights,$backupOwner,$backupBody))
{return ((0x10bd+ 1196-0x1568));}(my $fileBackup=($file."\x2e\x74\x6d\x70"));(my $fileDesc
=main::nxopen ($fileBackup,($NXBits::O_WRONLY+$NXBits::O_CREAT),$rights));unless
 (defined ($fileDesc)){Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x77\x72\x69\x74\x65\x20\x27"
.$fileBackup)."\x27\x2e"));return ((0x10aa+ 1710-0x1757));}if ((main::nxwrite (
$fileDesc,$fileBody)==(-(0x01c9+ 4774-0x146e)))){(my $errorNumber=
libnxh::NXGetError ());(my $errorstring=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".$errorNumber)."\x2c\x20").
$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((($backupOwner ne 
"\x72\x6f\x6f\x74")and ($backupOwner ne "\x6e\x78\x68\x74\x64"))){
changeFileOwnershipToNxIfRoot ($fileBackup);}return ((0x0b14+ 1611-0x115e));}
main::nxclose ($fileDesc);if ((($backupOwner ne "\x72\x6f\x6f\x74")and (
$backupOwner ne "\x6e\x78\x68\x74\x64"))){changeFileOwnershipToNxIfRoot (
$fileBackup);}unless (rename ($fileBackup,$file)){Logger::error (((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6e\x61\x6d\x65\x20\x66\x69\x6c\x65\x20\x27"
.$fileBackup)."\x27\x20\x74\x6f\x20\x27").$file).
"\x27\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20\x27").$!)."\x27\x2e"));return 
((0x0256+ 1362-0x07a7));}return ((0x18e8+ 2472-0x2290));}sub 
NXClusterTools::__appendFile{package NXClusterTools;no warnings;(my $file=shift 
(@_));(my $rights=shift (@_));(my $fileBody=shift (@_));(my $rightBackup=shift (
@_));(my $ownerBackup=shift (@_));if (__backupPrevious ($file,$rightBackup,
$ownerBackup)){return ((0x2246+ 390-0x23cb));}(my $fileExisted=
(0x0bb4+ 1828-0x12d8));if (Common::NXFile::fileExists ($file)){($fileExisted=
(0x0a24+ 693-0x0cd8));}(my $fileDesc=main::nxopen ($file,(($NXBits::O_WRONLY+
$NXBits::O_CREAT)+$NXBits::O_APPEND),$rights));unless (defined ($fileDesc)){
Logger::error (((
"\x45\x72\x72\x6f\x72\x20\x77\x68\x69\x6c\x65\x20\x6f\x70\x65\x6e\x69\x6e\x67\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x74\x6f\x20\x61\x70\x70\x65\x6e\x64\x2e"));return (
(0x0034+ 5148-0x144f));}if ((main::nxwrite ($fileDesc,$fileBody)==(-
(0x04ac+ 3236-0x114f)))){(my $errorNumber=libnxh::NXGetError ());(my $errorstring
=libnxh::NXGetErrorString ());Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x72\x69\x74\x65\x20\x74\x6f\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e"));Logger::error ((((("\x45\x72\x72\x6f\x72\x20\x69\x73\x3a\x20".
$errorNumber)."\x2c\x20").$errorstring)."\x2e"));main::nxclose ($fileDesc);if ((
not ($fileExisted))){if (($ownerBackup ne "\x72\x6f\x6f\x74")){
changeFileOwnershipToNxIfRoot ($file);}}return ((0x0495+ 7259-0x20ef));}
main::nxclose ($fileDesc);if ((not ($fileExisted))){
changeFileOwnershipToNxIfRoot ($file);}return ((0x09a8+ 7207-0x25cf));}sub 
NXClusterTools::__addClusterNodeKey{package NXClusterTools;no warnings;(my $message
=shift (@_));($message=main::urldecode ($message));return (addClusterKey (
$message));}sub NXClusterTools::checkUserNXConfigDir{package NXClusterTools;no 
warnings;(my $path=NXPaths::getConfigDir ());unless (
Common::NXFile::directoryExists ($path)){my ($error);unless (
Common::NXPaths::createAccessibleForNXDirectory ((\$error),$path)){return (
(0x1604+ 544-0x1824));}}return ((0x01a4+ 156-0x023f));}sub 
NXClusterTools::prepareNXKnownCerts{package NXClusterTools;no warnings;(my $refClusterHash
=shift (@_));my ($file);foreach my $key (keys (%$refClusterHash)){(my $value=
$$refClusterHash{$key});chomp ($value);if (
Common::NXShellCreate::isHostInCertFile ($key,NXPaths::getCurrentUserKnownCerts 
())){Common::NXShellCreate::removeCertificate ($key,$value,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$key).
"\x0a").$value)."\x0a"));}(my $myIp=$GLOBAL::ClusterOldLocal);(my $myCert=
getHostPublicCert ());chomp ($myCert);if (
Common::NXShellCreate::isHostInCertFile ($myIp,NXPaths::getCurrentUserKnownCerts
 ())){Common::NXShellCreate::removeCertificate ($myIp,$myCert,
NXPaths::getUserNXKnownCerts ());}($file.=(((("\x48\x6f\x73\x74\x3a".$myIp).
"\x0a").$myCert)."\x0a"));(my $hostCert=getClusterMasterCertPub ());if (
NXCluster::isSingleCert ()){($hostCert=getHostPublicCert ());}chomp ($hostCert);
if (Common::NXShellCreate::isHostInCertFile ($GLOBAL::ClusterHost,
NXPaths::getCurrentUserKnownCerts ())){Common::NXShellCreate::removeCertificate 
($GLOBAL::ClusterHost,$hostCert,NXPaths::getUserNXKnownCerts ());}($file.=((((
"\x48\x6f\x73\x74\x3a".$GLOBAL::ClusterHost)."\x0a").$hostCert)."\x0a"));($file
.=getPlayerCerts ());setClientCerts ($file);(my $path=
NXPaths::getUserNXKnownCerts ());changeFileOwnershipToNxIfRoot ($path);return (
$file);}sub NXClusterTools::__preparePublicKeys{package NXClusterTools;no 
warnings;(my $ref_publicKeys=shift (@_));(my $protocol=shift (@_));Logger::debug
 (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x50\x72\x65\x70\x61\x72\x65\x20\x70\x75\x62\x6c\x69\x63\x20\x6b\x65\x79\x73\x2e"
);(my $file=(""));my ($filePath);if (($protocol eq "\x53\x53\x48")){($filePath=
NXPaths::getNodePublicKeys ());}else{($filePath=NXPaths::getNXAuthorizedKeysPath
 ("\x6e\x78"));}(my $fileContent=Common::NXFile::getFileContent ($filePath));(my (
@oldContent)=split ( /\n/ ,$fileContent,(0x1c89+ 627-0x1efc)));(my $prefix=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=(("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH));($prefix.=
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
);foreach my $key (keys (%$ref_publicKeys)){(my $potentialKey=$$ref_publicKeys{
$key});(my $add=(0x07f5+ 1465-0x0dad));chomp ($potentialKey);($potentialKey=~ s/\r//g )
;if (($protocol eq "\x53\x53\x48")){($potentialKey=($prefix.$potentialKey));}
else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}foreach my $line
 (@oldContent){chomp ($line);($line=~ s/\r//g );if (($potentialKey eq $line)){(
$add=(0x17c6+ 3465-0x254f));last;}}if (($add==(0x0fe0+ 4831-0x22be))){($file.=(
$potentialKey."\x0a"));}}(my $potentialKey=getClusterPublicKey ());chomp (
$potentialKey);($potentialKey=~ s/\r//g );if (($protocol eq "\x53\x53\x48")){(
$potentialKey=($prefix.$potentialKey));}else{($potentialKey.=
"\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x43\x6c\x75\x73\x74\x65\x72");}(my $add
=(0x0191+ 6138-0x198a));foreach my $line (@oldContent){chomp ($line);($line=~ s/\r//g )
;if (($potentialKey eq $line)){($add=(0x1f9c+ 660-0x2230));last;}}if (($add==
(0x0255+ 4280-0x130c))){($file.=($potentialKey."\x0a"));}($file.=$fileContent);
if (($protocol eq "\x53\x53\x48")){setSSHAuthorizedCerts ($file);}else{
setAuthorizedCerts ($file);}return ($file);}sub 
NXClusterTools::prepareNXDPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x4e\x58"));}sub 
NXClusterTools::prepareSSHPublicKeys{package NXClusterTools;no warnings;(my $ref_publicKeys
=shift (@_));return (__preparePublicKeys ($ref_publicKeys,"\x53\x53\x48"));}sub 
NXClusterTools::prepareSSHClusterKey{package NXClusterTools;no warnings;(my $prefix
=
"\x6e\x6f\x2d\x70\x6f\x72\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c\x6e\x6f\x2d\x61\x67\x65\x6e\x74\x2d\x66\x6f\x72\x77\x61\x72\x64\x69\x6e\x67\x2c"
);($prefix.=((("\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x22".$GLOBAL::ETC_DIR).
$GLOBAL::DIRECTORY_SLASH).
"\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x72\x65\x6d\x6f\x74\x65\x6c\x6f\x67\x69\x6e\x22\x20"
));(my $key=($prefix.getClusterPublicKey ()));return ($key);}sub 
NXClusterTools::prepareKnownHostsSSH{package NXClusterTools;no warnings;(my $host
=shift (@_));(my $sshCrt=shift (@_));($sshCrt=~ s/\015//gs );my ($file);if ((
$sshCrt ne (""))){($file=(((($GLOBAL::ClusterPool."\x2c").$GLOBAL::ClusterHost).
"\x20").$sshCrt));}Common::NXShellCreate::removeCertificateSSH (
$GLOBAL::ClusterHost,(""),NXPaths::getUserKnownHostsSSH ());(my (@hosts)=split ( /,/ ,
$GLOBAL::ClusterPool,(0x0e24+ 3599-0x1c33)));foreach my $host (@hosts){
Common::NXShellCreate::removeCertificateSSH ($host,(""),
NXPaths::getUserKnownHostsSSH ());}($file.=getUserKnownHostsSSH ());
setKnownHostsSSH ($file);return ($file);}sub NXClusterTools::checkKeys{package 
NXClusterTools;no warnings;Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x66\x69\x6c\x65\x73\x2e"
);if ((not (Common::NXFile::fileExists (NXPaths::getClusterRSAPrivateKey ())))){
generateClusterKeys ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterRSAPublicKey ())))){generateClusterKeys ();}if ((not (
Common::NXFile::fileExists (NXPaths::getClusterHostPublicCert ())))){
generateClusterHostCerts ();}if ((not (Common::NXFile::fileExists (
NXPaths::getClusterHostPrivateCert ())))){generateClusterHostCerts ();}}sub 
NXClusterTools::changeFileOwnershipToNxIfRoot{package NXClusterTools;no warnings
;(my $file=shift (@_));(my $user=Common::NXCore::getEffectiveUsername ());if ((
$user eq "\x72\x6f\x6f\x74")){Logger::debug2 (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x6e\x78\x20\x27"
.$file)."\x27\x2e"));my ($errorName);my ($errorCode);if ((
Common::NXFile::setOwnershipForUserSilent ($file,"\x6e\x78",(\$errorName),(
\$errorCode))==(-(0x0f49+ 873-0x12b1)))){Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x0ab9+ 7107-0x267c));}}return ((0x100b+ 4955-0x2366));}sub 
NXClusterTools::__getPathToPublicKey{package NXClusterTools;no warnings;if (
__isRSAKeyAvailable ()){return (NXPaths::getClusterRSAPrivateKey ());}return (
NXPaths::getClusterDSAPrivateKey ());}sub NXClusterTools::getDatabaseInString{
package NXClusterTools;no warnings;(my $request=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65"
);($request.=
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x0a"
);(my $databaseString=(""));NXRedis::sendToDb ($request);(my $config=
NXRedis::get ());($config=~ s/ /,/g );($databaseString.=($config."\x0a"));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my $clusterList=NXRedis::get ());(my (@list)=split ( / / ,$clusterList,
(0x15b8+ 1967-0x1d67)));foreach $host (@list){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x67\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host).
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x0a"
));(my $line=NXRedis::get ());($line=~ s/ /,/g );($databaseString.=($line."\x0a"
));}return ($databaseString);}sub NXClusterTools::setDatabaseByString{package 
NXClusterTools;no warnings;(my $string=shift (@_));(my (@clusterList)=split ( /\n/ ,
$string,(0x0321+ 1981-0x0ade)));(my $redisString=__setConfigLine ($clusterList[
(0x0c21+ 6664-0x2629)]));NXRedis::sendToDb ($redisString);(my ($host1data,
$host1set)=__setHostLineS ($clusterList[(0x0c6f+ 1151-0x10ed)]));
NXRedis::sendToDb ($host1data);NXRedis::sendToDb ($host1set);(my ($host2data,
$host2set)=__setHostLineS ($clusterList[(0x10c8+ 3462-0x1e4c)]));
NXRedis::sendToDb ($host2data);NXRedis::sendToDb ($host2set);return (
(0x0a48+ 6846-0x2506));}sub NXClusterTools::__setConfigLine{package 
NXClusterTools;no warnings;(my $configLine=shift (@_));(my $record=
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67"
);(my (@options)=split ( /,/ ,$configLine,(0x0e5c+  30-0x0e7a)));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x73\x74\x65\x72\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x112a+ 1950-0x18c8)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x73\x68\x61\x72\x65\x64\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0ceb+ 1492-0x12be)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x74\x6f\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0b54+ 1576-0x117a)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x67\x72\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x1bf0+ 2298-0x24e7)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x72\x65\x74\x72\x79\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0462+ 5293-0x190b)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x70\x72\x6f\x62\x65\x2c\x76\x61\x6c\x75\x65\x3d".
$options[(0x0467+ 5817-0x1b1b)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x76\x61\x6c\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1157+ 4738-0x23d3)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x74\x69\x6d\x65\x6f\x75\x74\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x1250+ 2474-0x1bf3)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6d\x61\x69\x6e\x43\x6c\x75\x73\x74\x65\x72\x55\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x0288+ 4433-0x13d1)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x63\x6c\x75\x73\x74\x65\x72\x47\x55\x49\x44\x2c\x76\x61\x6c\x75\x65\x3d"
.$options[(0x125a+ 2015-0x1a30)]));($record.="\x0a");return ($record);}sub 
NXClusterTools::__setHostLineS{package NXClusterTools;no warnings;(my $hostLine=
shift (@_));(my (@host)=split ( /,/ ,$hostLine,(0x0e4c+ 5750-0x24c2)));(my $record
=(
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x68\x6d\x73\x65\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host[(0x00f8+ 4908-0x1424)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x68\x6f\x73\x74\x2c\x76\x61\x6c\x75\x65\x3d".$host
[(0x0a2f+ 3778-0x18f1)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x69\x6e\x74\x65\x72\x66\x61\x63\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x1920+ 1881-0x2078)]));($record.=(
"\x2c\x66\x69\x65\x6c\x64\x3d\x6e\x65\x74\x6d\x61\x73\x6b\x2c\x76\x61\x6c\x75\x65\x3d"
.$host[(0x14a3+ 4331-0x258c)]));($record.="\x0a");(my $setRecord=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x64\x64\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2c\x66\x69\x65\x6c\x64\x3d"
.$host[(0x0d92+ 482-0x0f74)])."\x0a"));return ($record,$setRecord);}sub 
NXClusterTools::cleanDb{package NXClusterTools;no warnings;NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x6d\x65\x6d\x62\x65\x72\x73\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);(my (@hosts)=split ( / / ,NXRedis::get (),(0x0abf+ 3239-0x1766)));
NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x0a"
);foreach my $host (@hosts){NXRedis::sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e"
.$host)."\x0a"));}NXRedis::sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x64\x65\x6c\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x63\x6c\x75\x73\x74\x65\x72\x2e\x63\x6f\x6e\x66\x69\x67\x0a"
);return ((0x0953+ 3937-0x18b4));}sub NXClusterTools::getServerCfgFile{package 
NXClusterTools;no warnings;(my $file=$GLOBAL::CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setServerCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+$NXBits::GroupRead)+
$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,(0x1218+  40-0x109c)
);return ((0x090a+ 6776-0x2382));}sub NXClusterTools::getNodeCfgFile{package 
NXClusterTools;no warnings;(my $file=$GLOBAL::NODE_CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setNodeCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::NODE_CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x09e0+ 2141-0x1099));return ((0x169b+ 808-0x19c3));}sub NXClusterTools::sync{
package NXClusterTools;no warnings;if (($GLOBAL::ClusterSyncDisabled==
(0x0815+ 1250-0x0cf6))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x43\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x20\x64\x69\x73\x61\x62\x6c\x65\x64\x2e"
);return ((0x0bb9+ 117-0x0c2d));}main::nxrequire (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72");if ((not (NXCluster::isClusterConfigured
 ()))){Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x6b\x69\x70\x20\x73\x79\x6e\x63\x20\x66\x6f\x72\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x66\x69\x67\x75\x72\x65\x64\x20\x63\x6c\x75\x73\x74\x65\x72\x2e"
);return;}Logger::debug (
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x63\x6c\x75\x73\x74\x65\x72\x20\x73\x79\x6e\x63\x2e"
);(my (@command)=());push (@command,($GLOBAL::ETC_DIR.
"\x2f\x6e\x78\x73\x65\x72\x76\x65\x72"));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){push
 (@command,"\x2d\x2d\x63\x6c\x75\x73\x74\x65\x72\x65\x64\x69\x74");}else{push (
@command,"\x2d\x2d\x73\x79\x6e\x63\x68\x72\x6f\x6e\x69\x7a\x65");}(my (@options)
=());(my $logfile=Common::NXPaths::getNXServerLogPath ());push (@options,
"\x73\x74\x64\x65\x72\x72",$logfile);push (@options,"\x73\x74\x64\x6f\x75\x74",
$logfile);push (@options,"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",(
"\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53\x3d".libnxh::NXTransGetEnvironment
 ("\x4e\x58\x5f\x46\x45\x41\x54\x55\x52\x45\x53")));push (@options,
"\x73\x65\x74\x20\x65\x6e\x76",("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e\x3d".
libnxh::NXTransGetEnvironment ("\x4e\x58\x5f\x56\x45\x52\x53\x49\x4f\x4e")));
main::run_command ((\@command),(\@options));}sub NXClusterTools::getWebCfgFile{
package NXClusterTools;no warnings;(my $file=$GLOBAL::HTD_CONFIG_FILE);return (
Common::NXFile::getFileContent ($file));}sub NXClusterTools::setWebCfgFile{
package NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
$GLOBAL::HTD_CONFIG_FILE);(my $rights=(($NXBits::UserReadWrite+
$NXBits::GroupRead)+$NXBits::OthersRead));__setFile ($file,$rights,$fileContent,
(0x02b0+ 9608-0x2694),"\x6e\x78\x68\x74\x64");return (changeFileOwnershipToNxhtd
 ($file,"\x63\x6f\x6e\x66\x69\x67"));}sub 
NXClusterTools::setHttpHostPublicCertFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHttpHostPublicCert ());(my $rights=((
$NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead));(my $ret=
__setFile ($file,$rights,$fileContent,(0x02a9+ 2297-0x09fe),
"\x6e\x78\x68\x74\x64"));return (changeFileOwnershipToNxhtd ($file,
"\x70\x75\x62\x6c\x69\x63\x43\x65\x72\x74"));}sub 
NXClusterTools::setHttpHostPrivateCertFile{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHttpHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);(my $orginalContent=(""));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user ne "\x72\x6f\x6f\x74")){(
$orginalContent=getHttpHostPrivateCertContent ($file));}(my $ret=__setFile (
$file,$rights,$fileContent,(0x14f0+ 4618-0x257a),"\x6e\x78\x68\x74\x64",
$orginalContent));return (changeFileOwnershipToNxhtd ($file,
"\x70\x72\x69\x76\x61\x74\x65\x43\x65\x72\x74"));}sub 
NXClusterTools::changeFileOwnershipToNxhtd{package NXClusterTools;no warnings;(my $file
=shift (@_));(my $param=shift (@_));(my $user=
Common::NXCore::getEffectiveUsername ());if (($user eq "\x72\x6f\x6f\x74")){(my (
@htdUsers)=NXTools::getNXHtdUser ());Logger::debug (((((
"\x4e\x58\x43\x6c\x75\x73\x74\x65\x72\x54\x6f\x6f\x6c\x73\x3a\x20\x53\x65\x74\x74\x69\x6e\x67\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20"
.$htdUsers[(0x01d3+ 4001-0x1174)])."\x2c\x20").$file)."\x2e"));my ($errorName);my (
$errorCode);if ((Common::NXFile::setOwnershipForUserSilent ($file,$htdUsers[
(0x19f0+ 1681-0x2081)],(\$errorName),(\$errorCode))==(-(0x189c+ 3223-0x2532)))){
Logger::error ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20"
.$file)."\x2e\x20").$errorCode)."\x20").$errorName));NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",(($file."\x2e\x20").$errorName));unlink ($file);
main::nxexit ((0x17dc+ 624-0x1a4c));}}else{(my (@command)=());(my (@parameters)=
());push (@command,$GLOBAL::CommandNXexec,$GLOBAL::SCRIPT_NXHTDCHOWN,$param);(my (
$cmd_err,$cmd_out,$exit_value)=main::run_command ((\@command),(\@parameters)));
if (($exit_value!=(0x1233+ 4079-0x2222))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x74\x6f\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27").
$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne 
(""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x53\x65\x74\x4f\x77\x6e\x65\x72\x73\x68\x69\x70",
"\x4e\x58\x53\x68\x65\x6c\x6c",$file);main::nxexit ((0x0be8+ 2982-0x178e));}}
return ((0x1287+ 847-0x15d6));}sub NXClusterTools::getHttpHostPrivateCertContent
{package NXClusterTools;no warnings;(my $file=shift (@_));(my (@command)=());(my (
@parameters)=());push (@command,$GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXWEBHOSTCERTGET);(my ($cmd_err,$cmd_out,$exit_value)=
main::run_command ((\@command),(\@parameters)));if (($exit_value!=
(0x03f2+ 956-0x07ae))){Logger::error (((((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x66\x69\x6c\x65\x20\x27".$file).
"\x27\x20\x63\x6f\x6e\x74\x65\x6e\x74\x2e\x20\x45\x78\x69\x74\x20\x76\x61\x6c\x75\x65\x20\x27"
).$exit_value)."\x27\x20").$cmd_out)."\x20").$cmd_err)."\x2e"));if (($cmd_out ne
 (""))){($file.=("\x2e\x20".$cmd_out));}NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x46\x69\x6c\x65",
"\x4e\x58\x53\x68\x65\x6c\x6c",$file);main::nxexit ((0x14d5+ 2338-0x1df7));}
return ($cmd_out);return ((""));}sub NXClusterTools::getHostPrivateCert{package 
NXClusterTools;no warnings;(my $file=NXPaths::getHostPrivateCert ());(my $content
=Common::NXFile::getFileContent ($file));return ($content);}sub 
NXClusterTools::setHostPrivateCert{package NXClusterTools;no warnings;(my $fileContent
=shift (@_));(my $file=NXPaths::getHostPrivateCert ());(my $rights=
$NXBits::UserReadWrite);__setFile ($file,$rights,$fileContent,
(0x01e6+ 430-0x0214));return ((0x014d+ 979-0x0520));}sub 
NXClusterTools::getHostPublicCert{package NXClusterTools;no warnings;(my $file=
NXPaths::getHostPublicCert ());(my $content=Common::NXFile::getFileContent (
$file));return ($content);}sub NXClusterTools::setHostPublicCert{package 
NXClusterTools;no warnings;(my $fileContent=shift (@_));(my $file=
NXPaths::getHostPublicCert ());(my $rights=$NXBits::UserReadWrite);__setFile (
$file,$rights,$fileContent,(0x0ddf+ 6620-0x263b));return ((0x0bf2+ 2269-0x14cf))
;}package NXClusterTools;no warnings;return ((0x0c0f+ 4426-0x1d58));
